
/*  This file is part of the program psim.

    Copyright (C) 1994-1995, Andrew Cagney <cagney@highland.com.au>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
    --

    This file was generated by the program igen */

#ifndef _SEMANTICS_C_
#define _SEMANTICS_C_


#include "cpu.h"
#include "idecode.h"
#include "semantics.h"
#ifdef HAVE_COMMON_FPU
#include "sim-inline.h"
#include "sim-fpu.h"
#endif
#include "support.h"

int option_mpc860c0 = 0;

PSIM_EXTERN_SEMANTICS(void)
semantic_init(device* root)
{
  option_mpc860c0 = 0;
  if (tree_find_property(root, "/options/mpc860c0"))
    option_mpc860c0 = tree_find_integer_property(root, "/options/mpc860c0");
    option_mpc860c0 *= 4;   /* convert word count to byte count */
}


PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_instruction_call(cpu *processor,
                          idecode_cache *cache_entry,
                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_instruction_call
#undef MY_PREFIX
#define MY_PREFIX instruction_call

  /* extraction: 0.0,6./,11./,16./,21./,31.1 #define get-values-from-icache */
#line 62 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1494 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics instruction_call\n"));
#line 68 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_instruction_call, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1494 "../.././sim/ppc/ppc-instructions"
  {
    if (!os_emul_instruction_call(processor, cia, real_addr(cia, 1)))
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
  }
#line 83 "semantics.c"
  return nia;
  /* extraction: 0.0,6./,11./,16./,21./,31.1 #undef get-values-from-icache */
#line 86 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Trap_Word_Immediate(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Trap_Word_Immediate
#undef MY_PREFIX
#define MY_PREFIX Trap_Word_Immediate

  /* extraction: 0.3,6.TO,11.RA,16.SI #define get-values-from-icache */
#define TO cache_entry->crack.D.TO /* default in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 109 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2898 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Trap Word Immediate\n"));
#line 115 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Trap_Word_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2898 "../.././sim/ppc/ppc-instructions"
  {
    signed_word a = EXTENDED(*rA);
    signed_word b = EXTS(SI);
    if ((a < b && TO_0_)
        || (a > b && TO_1_)
        || (a == b && TO_2_)
        || ((unsigned_word)a < (unsigned_word)b && TO_3_)
        || ((unsigned_word)a > (unsigned_word)b && TO_4_)
        )
      program_interrupt(processor, cia,
                        trap_program_interrupt);
  }
#line 137 "semantics.c"
  return nia;
  /* extraction: 0.3,6.TO,11.RA,16.SI #undef get-values-from-icache */
#undef TO
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 146 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_Low_Immediate(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Immediate
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Immediate

  /* extraction: 0.7,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 171 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2688 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply Low Immediate\n"));
#line 177 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_Low_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2688 "../.././sim/ppc/ppc-instructions"
  {
    signed_word prod = *rA * EXTS(SI);
    *rT = prod;
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, 0/*Rc*/);
  }
#line 192 "semantics.c"
  return nia;
  /* extraction: 0.7,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 203 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Immediate_Carrying(cpu *processor,
                                          idecode_cache *cache_entry,
                                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Immediate_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Immediate_Carrying

  /* extraction: 0.8,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 228 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2575 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Immediate Carrying\n"));
#line 234 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Immediate_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2575 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(EXTS(SI));
    ALU_ADD(1);
    ALU_END(*rT, 1/*CA*/, 0/*OE*/, 0/*Rc*/);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, 0/*Rc*/);
  }
#line 252 "semantics.c"
  return nia;
  /* extraction: 0.8,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 263 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Compare_Logical_Immediate(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Compare_Logical_Immediate
#undef MY_PREFIX
#define MY_PREFIX Compare_Logical_Immediate

  /* extraction: 0.10,6.BF,9./,10.L,11.RA,16.UI #define get-values-from-icache */
#define BF cache_entry->crack.D.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.D.BF_BITMASK /* in icache - extraction */
#define L cache_entry->crack.D.L /* default in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 288 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2834 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Compare Logical Immediate\n"));
#line 294 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Compare_Logical_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2834 "../.././sim/ppc/ppc-instructions"
  {
    if (!is_64bit_mode && L)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      unsigned_word a;
      unsigned_word b = UI;
      if (L == 0)
        a = MASKED(*rA, 32, 63);
      else
        a = *rA;
      CR_COMPARE(BF, a, b);
    }
    PPC_INSN_INT_CR(0, RA_BITMASK, BF_BITMASK);
  }
#line 319 "semantics.c"
  return nia;
  /* extraction: 0.10,6.BF,9./,10.L,11.RA,16.UI #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef L
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 330 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Compare_Immediate(cpu *processor,
                           idecode_cache *cache_entry,
                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Compare_Immediate
#undef MY_PREFIX
#define MY_PREFIX Compare_Immediate

  /* extraction: 0.11,6.BF,9./,10.L,11.RA,16.SI #define get-values-from-icache */
#define BF cache_entry->crack.D.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.D.BF_BITMASK /* in icache - extraction */
#define L cache_entry->crack.D.L /* default in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 355 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2792 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Compare Immediate\n"));
#line 361 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Compare_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2792 "../.././sim/ppc/ppc-instructions"
  {
    if (!is_64bit_mode && L)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      signed_word a;
      signed_word b = EXTS(SI);
      if (L == 0)
        a = EXTENDED(*rA);
      else
        a = *rA;
      CR_COMPARE(BF, a, b);
    }
    PPC_INSN_INT_CR(0, RA_BITMASK, BF_BITMASK);
  }
#line 386 "semantics.c"
  return nia;
  /* extraction: 0.11,6.BF,9./,10.L,11.RA,16.SI #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef L
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 397 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Immediate_Carrying(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_Carrying

  /* extraction: 0.12,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 422 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2555 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Immediate Carrying\n"));
#line 428 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Immediate_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2555 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(EXTS(SI));
    ALU_END(*rT, 1/*CA*/, 0/*OE*/, 0/*Rc*/);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, 0/*Rc*/);
  }
#line 444 "semantics.c"
  return nia;
  /* extraction: 0.12,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 455 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Immediate_Carrying_and_Record(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate_Carrying_and_Record
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_Carrying_and_Record

  /* extraction: 0.13,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 480 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2565 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Immediate Carrying and Record\n"));
#line 486 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Immediate_Carrying_and_Record, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2565 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(EXTS(SI));
    ALU_END(*rT, 1/*CA*/, 0/*OE*/, 1/*Rc*/);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, 1/*Rc*/);
  }
#line 502 "semantics.c"
  return nia;
  /* extraction: 0.13,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 513 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Immediate_RA0(cpu *processor,
                           idecode_cache *cache_entry,
                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_RA0

  /* extraction: 0.14,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA 0 /* in icache - constant field */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 1 /* RA == 0 */ /* semantic compute - constant compare */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 538 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2513 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Immediate\n"));
#line 544 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2513 "../.././sim/ppc/ppc-instructions"
  {
    if (RA_is_0)	*rT = EXTS(SI);
    else		*rT = *rA + EXTS(SI);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rT, (long)*rT));
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 560 "semantics.c"
  return nia;
  /* extraction: 0.14,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 571 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Immediate_RA(cpu *processor,
                          idecode_cache *cache_entry,
                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_RA

  /* extraction: 0.14,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 0 /* RA == 0 */ /* semantic compute - constant compare */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 596 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2513 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Immediate\n"));
#line 602 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2513 "../.././sim/ppc/ppc-instructions"
  {
    if (RA_is_0)	*rT = EXTS(SI);
    else		*rT = *rA + EXTS(SI);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rT, (long)*rT));
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 618 "semantics.c"
  return nia;
  /* extraction: 0.14,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 629 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Immediate_Shifted_RA0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_Shifted_RA0

  /* extraction: 0.15,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA 0 /* in icache - constant field */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 1 /* RA == 0 */ /* semantic compute - constant compare */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 654 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2523 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Immediate Shifted\n"));
#line 660 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Immediate_Shifted, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2523 "../.././sim/ppc/ppc-instructions"
  {
    if (RA_is_0)	*rT = EXTS(SI) << 16;
    else		*rT = *rA + (EXTS(SI) << 16);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rT, (long)*rT));
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 676 "semantics.c"
  return nia;
  /* extraction: 0.15,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 687 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Immediate_Shifted_RA(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_Shifted_RA

  /* extraction: 0.15,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 0 /* RA == 0 */ /* semantic compute - constant compare */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 712 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2523 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Immediate Shifted\n"));
#line 718 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Immediate_Shifted, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2523 "../.././sim/ppc/ppc-instructions"
  {
    if (RA_is_0)	*rT = EXTS(SI) << 16;
    else		*rT = *rA + (EXTS(SI) << 16);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rT, (long)*rT));
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 734 "semantics.c"
  return nia;
  /* extraction: 0.15,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 745 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO0

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 0 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 767 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 773 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 822 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 830 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO1

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 1 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 852 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 858 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 907 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 915 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO2(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO2

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 2 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 937 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 943 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 992 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1000 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO3(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO3

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 3 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1022 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1028 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1077 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1085 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO4(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO4

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 4 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1107 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1113 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1162 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1170 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO5(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO5

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 5 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1192 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1198 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1247 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1255 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO6(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO6

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 6 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1277 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1283 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1332 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1340 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO7(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO7

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 7 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1362 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1368 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1417 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1425 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO8(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO8

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 8 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1447 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1453 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1502 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1510 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO9(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO9

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 9 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1532 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1538 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1587 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1595 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO10(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO10

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 10 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1617 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1623 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1672 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1680 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO11(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO11

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 11 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1702 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1708 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1757 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1765 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO12(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO12

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 12 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1787 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1793 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1842 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1850 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO13(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO13

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 13 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1872 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1878 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1927 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1935 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO14(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO14

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 14 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1957 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1963 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2012 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2020 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO15(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO15

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 15 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2042 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2048 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2097 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2105 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO16(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO16

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 16 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2127 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2133 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2182 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2190 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO17(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO17

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 17 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2212 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2218 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2267 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2275 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO18(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO18

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 18 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2297 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2303 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2352 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2360 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO19(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO19

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 19 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2382 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2388 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2437 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2445 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO20(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO20

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 20 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2467 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2473 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2522 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2530 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO21(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO21

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 21 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2552 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2558 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2607 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2615 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO22(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO22

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 22 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2637 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2643 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2692 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2700 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO23(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO23

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 23 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2722 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2728 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2777 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2785 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO24(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO24

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 24 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2807 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2813 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2862 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2870 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO25(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO25

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 25 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2892 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2898 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2947 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2955 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO26(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO26

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 26 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2977 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2983 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3032 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3040 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO27(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO27

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 27 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 3062 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3068 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3117 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3125 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO28(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO28

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 28 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 3147 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3153 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3202 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3210 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO29(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO29

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 29 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 3232 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3238 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3287 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3295 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO30(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO30

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 30 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 3317 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3323 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3372 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3380 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO31(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO31

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 31 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 3402 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3408 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3457 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3465 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO0

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 0 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3487 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3493 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3542 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3550 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO1

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 1 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3572 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3578 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3627 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3635 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO2(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO2

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 2 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3657 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3663 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3712 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3720 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO3(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO3

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 3 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3742 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3748 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3797 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3805 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO4(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO4

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 4 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3827 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3833 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3882 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3890 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO5(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO5

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 5 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3912 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3918 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3967 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3975 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO6(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO6

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 6 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3997 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4003 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4052 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4060 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO7(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO7

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 7 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4082 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4088 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4137 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4145 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO8(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO8

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 8 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4167 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4173 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4222 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4230 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO9(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO9

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 9 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4252 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4258 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4307 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4315 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO10(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO10

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 10 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4337 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4343 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4392 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4400 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO11(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO11

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 11 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4422 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4428 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4477 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4485 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO12(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO12

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 12 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4507 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4513 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4562 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4570 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO13(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO13

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 13 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4592 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4598 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4647 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4655 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO14(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO14

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 14 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4677 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4683 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4732 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4740 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO15(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO15

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 15 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4762 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4768 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4817 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4825 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO16(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO16

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 16 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4847 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4853 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4902 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4910 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO17(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO17

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 17 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4932 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4938 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4987 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4995 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO18(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO18

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 18 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5017 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5023 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5072 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5080 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO19(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO19

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 19 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5102 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5108 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5157 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5165 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO20(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO20

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 20 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5187 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5193 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5242 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5250 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO21(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO21

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 21 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5272 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5278 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5327 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5335 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO22(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO22

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 22 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5357 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5363 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5412 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5420 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO23(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO23

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 23 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5442 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5448 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5497 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5505 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO24(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO24

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 24 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5527 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5533 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5582 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5590 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO25(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO25

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 25 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5612 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5618 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5667 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5675 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO26(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO26

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 26 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5697 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5703 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5752 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5760 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO27(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO27

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 27 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5782 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5788 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5837 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5845 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO28(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO28

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 28 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5867 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5873 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5922 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5930 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO29(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO29

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 29 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5952 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5958 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6007 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6015 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO30(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO30

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 30 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 6037 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6043 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6092 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6100 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO31(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO31

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 31 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 6122 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6128 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6177 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6185 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO0

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 0 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6207 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6213 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6262 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6270 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO1

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 1 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6292 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6298 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6347 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6355 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO2(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO2

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 2 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6377 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6383 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6432 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6440 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO3(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO3

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 3 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6462 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6468 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6517 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6525 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO4(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO4

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 4 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6547 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6553 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6602 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6610 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO5(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO5

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 5 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6632 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6638 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6687 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6695 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO6(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO6

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 6 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6717 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6723 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6772 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6780 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO7(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO7

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 7 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6802 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6808 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6857 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6865 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO8(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO8

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 8 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6887 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6893 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6942 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6950 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO9(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO9

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 9 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6972 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6978 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7027 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7035 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO10(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO10

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 10 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7057 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7063 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7112 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7120 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO11(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO11

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 11 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7142 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7148 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7197 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7205 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO12(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO12

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 12 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7227 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7233 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7282 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7290 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO13(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO13

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 13 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7312 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7318 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7367 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7375 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO14(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO14

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 14 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7397 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7403 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7452 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7460 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO15(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO15

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 15 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7482 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7488 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7537 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7545 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO16(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO16

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 16 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7567 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7573 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7622 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7630 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO17(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO17

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 17 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7652 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7658 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7707 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7715 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO18(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO18

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 18 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7737 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7743 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7792 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7800 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO19(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO19

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 19 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7822 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7828 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7877 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7885 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO20(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO20

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 20 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7907 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7913 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7962 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7970 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO21(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO21

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 21 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7992 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7998 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8047 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8055 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO22(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO22

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 22 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8077 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8083 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8132 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8140 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO23(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO23

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 23 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8162 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8168 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8217 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8225 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO24(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO24

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 24 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8247 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8253 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8302 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8310 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO25(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO25

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 25 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8332 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8338 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8387 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8395 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO26(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO26

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 26 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8417 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8423 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8472 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8480 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO27(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO27

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 27 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8502 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8508 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8557 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8565 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO28(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO28

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 28 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8587 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8593 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8642 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8650 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO29(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO29

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 29 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8672 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8678 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8727 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8735 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO30(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO30

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 30 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8757 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8763 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8812 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8820 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO31(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO31

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 31 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8842 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8848 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8897 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8905 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO0

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 0 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 8927 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8933 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8982 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8990 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO1

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 1 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9012 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9018 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9067 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9075 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO2(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO2

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 2 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9097 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9103 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9152 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9160 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO3(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO3

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 3 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9182 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9188 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9237 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9245 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO4(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO4

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 4 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9267 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9273 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9322 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9330 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO5(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO5

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 5 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9352 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9358 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9407 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9415 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO6(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO6

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 6 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9437 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9443 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9492 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9500 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO7(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO7

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 7 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9522 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9528 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9577 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9585 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO8(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO8

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 8 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9607 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9613 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9662 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9670 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO9(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO9

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 9 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9692 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9698 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9747 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9755 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO10(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO10

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 10 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9777 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9783 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9832 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9840 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO11(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO11

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 11 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9862 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9868 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9917 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9925 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO12(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO12

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 12 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9947 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9953 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10002 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10010 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO13(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO13

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 13 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10032 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10038 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10087 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10095 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO14(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO14

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 14 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10117 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10123 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10172 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10180 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO15(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO15

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 15 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10202 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10208 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10257 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10265 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO16(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO16

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 16 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10287 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10293 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10342 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10350 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO17(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO17

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 17 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10372 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10378 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10427 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10435 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO18(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO18

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 18 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10457 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10463 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10512 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10520 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO19(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO19

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 19 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10542 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10548 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10597 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10605 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO20(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO20

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 20 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10627 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10633 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10682 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10690 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO21(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO21

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 21 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10712 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10718 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10767 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10775 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO22(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO22

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 22 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10797 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10803 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10852 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10860 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO23(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO23

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 23 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10882 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10888 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10937 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10945 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO24(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO24

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 24 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10967 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10973 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11022 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11030 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO25(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO25

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 25 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11052 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11058 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11107 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11115 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO26(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO26

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 26 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11137 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11143 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11192 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11200 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO27(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO27

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 27 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11222 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11228 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11277 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11285 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO28(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO28

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 28 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11307 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11313 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11362 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11370 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO29(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO29

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 29 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11392 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11398 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11447 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11455 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO30(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO30

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 30 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11477 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11483 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11532 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11540 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO31(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO31

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 31 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11562 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11568 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11617 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11625 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_System_Call(cpu *processor,
                     idecode_cache *cache_entry,
                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_System_Call
#undef MY_PREFIX
#define MY_PREFIX System_Call

  /* extraction: 0.17,6./,11./,16./,30.1,31./ #define get-values-from-icache */
#line 11642 "semantics.c"

#define insn cache_entry->crack.SC.insn
  unsigned_word nia;
#line 1631 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics System Call\n"));
#line 11648 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_System_Call, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1631 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL_ISSUE > 0)
      model_serialize(MY_INDEX, cpu_model(processor));
    system_call_interrupt(processor, cia);
  }
#line 11663 "semantics.c"
  return nia;
  /* extraction: 0.17,6./,11./,16./,30.1,31./ #undef get-values-from-icache */
#line 11666 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_AA0_LK0(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch
#undef MY_PREFIX
#define MY_PREFIX Branch_AA0_LK0

  /* extraction: 0.18,6.LI,30.AA,31.LK #define get-values-from-icache */
#define EXTS_LI_0b00 cache_entry->crack.I.EXTS_LI_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 11686 "semantics.c"

#define insn cache_entry->crack.I.insn
  unsigned_word nia;
#line 1506 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch\n"));
#line 11692 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1506 "../.././sim/ppc/ppc-instructions"
  {
    /* option_mpc860c0:
    No problem here because this branch is predicted taken (unconditional). */
    if (AA) NIA = IEA(EXTS(LI_0b00));
    else    NIA = IEA(CIA + EXTS(LI_0b00));
    if (LK) LR = (spreg)CIA+4;
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), 1, -1);
  }
#line 11711 "semantics.c"
  return nia;
  /* extraction: 0.18,6.LI,30.AA,31.LK #undef get-values-from-icache */
#undef EXTS_LI_0b00
#undef AA
#undef LK
#line 11717 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_AA0_LK1(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch
#undef MY_PREFIX
#define MY_PREFIX Branch_AA0_LK1

  /* extraction: 0.18,6.LI,30.AA,31.LK #define get-values-from-icache */
#define EXTS_LI_0b00 cache_entry->crack.I.EXTS_LI_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11737 "semantics.c"

#define insn cache_entry->crack.I.insn
  unsigned_word nia;
#line 1506 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch\n"));
#line 11743 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1506 "../.././sim/ppc/ppc-instructions"
  {
    /* option_mpc860c0:
    No problem here because this branch is predicted taken (unconditional). */
    if (AA) NIA = IEA(EXTS(LI_0b00));
    else    NIA = IEA(CIA + EXTS(LI_0b00));
    if (LK) LR = (spreg)CIA+4;
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), 1, -1);
  }
#line 11762 "semantics.c"
  return nia;
  /* extraction: 0.18,6.LI,30.AA,31.LK #undef get-values-from-icache */
#undef EXTS_LI_0b00
#undef AA
#undef LK
#line 11768 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_AA1_LK0(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch
#undef MY_PREFIX
#define MY_PREFIX Branch_AA1_LK0

  /* extraction: 0.18,6.LI,30.AA,31.LK #define get-values-from-icache */
#define EXTS_LI_0b00 cache_entry->crack.I.EXTS_LI_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 11788 "semantics.c"

#define insn cache_entry->crack.I.insn
  unsigned_word nia;
#line 1506 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch\n"));
#line 11794 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1506 "../.././sim/ppc/ppc-instructions"
  {
    /* option_mpc860c0:
    No problem here because this branch is predicted taken (unconditional). */
    if (AA) NIA = IEA(EXTS(LI_0b00));
    else    NIA = IEA(CIA + EXTS(LI_0b00));
    if (LK) LR = (spreg)CIA+4;
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), 1, -1);
  }
#line 11813 "semantics.c"
  return nia;
  /* extraction: 0.18,6.LI,30.AA,31.LK #undef get-values-from-icache */
#undef EXTS_LI_0b00
#undef AA
#undef LK
#line 11819 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_AA1_LK1(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch
#undef MY_PREFIX
#define MY_PREFIX Branch_AA1_LK1

  /* extraction: 0.18,6.LI,30.AA,31.LK #define get-values-from-icache */
#define EXTS_LI_0b00 cache_entry->crack.I.EXTS_LI_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11839 "semantics.c"

#define insn cache_entry->crack.I.insn
  unsigned_word nia;
#line 1506 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch\n"));
#line 11845 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1506 "../.././sim/ppc/ppc-instructions"
  {
    /* option_mpc860c0:
    No problem here because this branch is predicted taken (unconditional). */
    if (AA) NIA = IEA(EXTS(LI_0b00));
    else    NIA = IEA(CIA + EXTS(LI_0b00));
    if (LK) LR = (spreg)CIA+4;
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), 1, -1);
  }
#line 11864 "semantics.c"
  return nia;
  /* extraction: 0.18,6.LI,30.AA,31.LK #undef get-values-from-icache */
#undef EXTS_LI_0b00
#undef AA
#undef LK
#line 11870 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_Condition_Register_Field(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_Condition_Register_Field
#undef MY_PREFIX
#define MY_PREFIX Move_Condition_Register_Field

  /* extraction: 0.19,6.BF,9./,11.BFA,14./,16./,21.0,31./ #define get-values-from-icache */
#define BF cache_entry->crack.XL.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.XL.BF_BITMASK /* in icache - extraction */
#define BFA cache_entry->crack.XL.BFA /* default in icache - extraction */
#line 11890 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1710 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move Condition Register Field\n"));
#line 11896 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_Condition_Register_Field, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1710 "../.././sim/ppc/ppc-instructions"
  {
    MBLIT32(CR, 4*BF, 4*BF+3, EXTRACTED32(CR, 4*BFA, 4*BFA+3));
    PPC_INSN_CR(BF_BITMASK, 1 << BFA);
  }
#line 11910 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BF,9./,11.BFA,14./,16./,21.0,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef BFA
#line 11916 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_to_Link_Register_LK0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional_to_Link_Register
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_to_Link_Register_LK0

  /* extraction: 0.19,6.BO,11.BI,16./,21.16,31.LK #define get-values-from-icache */
#define BO cache_entry->crack.XL.BO /* default in icache - extraction */
#define BIT32_BI cache_entry->crack.XL.BIT32_BI /* in icache - extraction */
#define LK 0 /* default in icache - constant field */
#line 11936 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1562 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional to Link Register\n"));
#line 11942 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional_to_Link_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1562 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != BO_3_);
    cond_ok = BO_0_ || (CR_BI_ == BO_1_);
    if (ctr_ok && cond_ok) {
      NIA = IEA(LR_0b00);
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as not-taken.
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0) {
      model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_)
        model_branch_predict(cpu_model(processor), BO_4_ ? !succeed : succeed);
    }
  }
#line 11983 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BO,11.BI,16./,21.16,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef LK
#line 11989 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_to_Link_Register_LK1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional_to_Link_Register
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_to_Link_Register_LK1

  /* extraction: 0.19,6.BO,11.BI,16./,21.16,31.LK #define get-values-from-icache */
#define BO cache_entry->crack.XL.BO /* default in icache - extraction */
#define BIT32_BI cache_entry->crack.XL.BIT32_BI /* in icache - extraction */
#define LK 1 /* default in icache - constant field */
#line 12009 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1562 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional to Link Register\n"));
#line 12015 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional_to_Link_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1562 "../.././sim/ppc/ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != BO_3_);
    cond_ok = BO_0_ || (CR_BI_ == BO_1_);
    if (ctr_ok && cond_ok) {
      NIA = IEA(LR_0b00);
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as not-taken.
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0) {
      model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_)
        model_branch_predict(cpu_model(processor), BO_4_ ? !succeed : succeed);
    }
  }
#line 12056 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BO,11.BI,16./,21.16,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef LK
#line 12062 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_NOR(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_NOR
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_NOR

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.33,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12085 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1675 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register NOR\n"));
#line 12091 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_NOR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1675 "../.././sim/ppc/ppc-instructions"
  {
    BLIT32(CR, BT, !(CR_BA_ || CR_BB_));
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12105 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.33,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12114 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Return_From_Interrupt(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Return_From_Interrupt
#undef MY_PREFIX
#define MY_PREFIX Return_From_Interrupt

  /* extraction: 0.19,6./,11./,16./,21.50,31./ #define get-values-from-icache */
#line 12131 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 4839 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Return From Interrupt\n"));
#line 12137 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Return_From_Interrupt, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4839 "../.././sim/ppc/ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor)) {
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    }
    else {
      MSR = (MASKED(SRR1, 0, 32)
             | MASKED(SRR1, 37, 41)
             | MASKED(SRR1, 48, 63));
      NIA = MASKED(SRR0, 0, 61);
      cpu_synchronize_context(processor, cia);
      check_masked_interrupts(processor);
    }
  }
#line 12161 "semantics.c"
  return nia;
  /* extraction: 0.19,6./,11./,16./,21.50,31./ #undef get-values-from-icache */
#line 12164 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_AND_with_Complement(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_AND_with_Complement
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_AND_with_Complement

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.129,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12187 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1691 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register AND with Complement\n"));
#line 12193 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_AND_with_Complement, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1691 "../.././sim/ppc/ppc-instructions"
  {
    BLIT32(CR, BT, CR_BA_ && !CR_BB_);
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12207 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.129,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12216 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Instruction_Synchronize(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Instruction_Synchronize
#undef MY_PREFIX
#define MY_PREFIX Instruction_Synchronize

  /* extraction: 0.19,6./,11./,16./,21.150,31./ #define get-values-from-icache */
#line 12233 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 4752 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Instruction Synchronize\n"));
#line 12239 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Instruction_Synchronize, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4752 "../.././sim/ppc/ppc-instructions"
  {
    cpu_synchronize_context(processor, cia);
    PPC_INSN_INT(0, 0, 0);
  }
#line 12253 "semantics.c"
  return nia;
  /* extraction: 0.19,6./,11./,16./,21.150,31./ #undef get-values-from-icache */
#line 12256 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_XOR(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_XOR
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_XOR

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.193,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12279 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1659 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register XOR\n"));
#line 12285 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_XOR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1659 "../.././sim/ppc/ppc-instructions"
  {
    BLIT32(CR, BT, CR_BA_ != CR_BB_);
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12299 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.193,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12308 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_NAND(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_NAND
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_NAND

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.225,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12331 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1667 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register NAND\n"));
#line 12337 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_NAND, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1667 "../.././sim/ppc/ppc-instructions"
  {
    BLIT32(CR, BT, !(CR_BA_ && CR_BB_));
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12351 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.225,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12360 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_AND(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_AND
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_AND

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.257,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12383 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1643 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register AND\n"));
#line 12389 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_AND, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1643 "../.././sim/ppc/ppc-instructions"
  {
    BLIT32(CR, BT, CR_BA_ && CR_BB_);
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12403 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.257,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12412 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_Equivalent(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_Equivalent
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_Equivalent

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.289,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12435 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1683 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register Equivalent\n"));
#line 12441 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_Equivalent, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1683 "../.././sim/ppc/ppc-instructions"
  {
    BLIT32(CR, BT, CR_BA_ == CR_BB_);
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12455 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.289,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12464 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_OR_with_Complement(cpu *processor,
                                               idecode_cache *cache_entry,
                                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_OR_with_Complement
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_OR_with_Complement

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.417,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12487 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1699 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register OR with Complement\n"));
#line 12493 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_OR_with_Complement, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1699 "../.././sim/ppc/ppc-instructions"
  {
    BLIT32(CR, BT, CR_BA_ || !CR_BB_);
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12507 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.417,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12516 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_OR(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_OR
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_OR

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.449,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12539 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1651 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register OR\n"));
#line 12545 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_OR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1651 "../.././sim/ppc/ppc-instructions"
  {
    BLIT32(CR, BT, CR_BA_ || CR_BB_);
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12559 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.449,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12568 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_to_Count_Register_LK0(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional_to_Count_Register
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_to_Count_Register_LK0

  /* extraction: 0.19,6.BO,11.BI,16./,21.528,31.LK #define get-values-from-icache */
#define BO cache_entry->crack.XL.BO /* default in icache - extraction */
#define BIT32_BI cache_entry->crack.XL.BIT32_BI /* in icache - extraction */
#define LK 0 /* default in icache - constant field */
#line 12588 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1597 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional to Count Register\n"));
#line 12594 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional_to_Count_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1597 "../.././sim/ppc/ppc-instructions"
  {
    int cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    cond_ok = BO_0_ || (CR_BI_ == BO_1_);
    if (cond_ok) {
      NIA = IEA(CTR_0b00);
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as not-taken.
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0) {
      model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_)
        model_branch_predict(cpu_model(processor), BO_4_ ? !succeed : succeed);
    }
  }
#line 12631 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BO,11.BI,16./,21.528,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef LK
#line 12637 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_to_Count_Register_LK1(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional_to_Count_Register
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_to_Count_Register_LK1

  /* extraction: 0.19,6.BO,11.BI,16./,21.528,31.LK #define get-values-from-icache */
#define BO cache_entry->crack.XL.BO /* default in icache - extraction */
#define BIT32_BI cache_entry->crack.XL.BIT32_BI /* in icache - extraction */
#define LK 1 /* default in icache - constant field */
#line 12657 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1597 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional to Count Register\n"));
#line 12663 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional_to_Count_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1597 "../.././sim/ppc/ppc-instructions"
  {
    int cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    cond_ok = BO_0_ || (CR_BI_ == BO_1_);
    if (cond_ok) {
      NIA = IEA(CTR_0b00);
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as not-taken.
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0) {
      model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_)
        model_branch_predict(cpu_model(processor), BO_4_ ? !succeed : succeed);
    }
  }
#line 12700 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BO,11.BI,16./,21.528,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef LK
#line 12706 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Rotate_Left_Word_Immediate_then_Mask_Insert_Rc0(cpu *processor,
                                                         idecode_cache *cache_entry,
                                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_Immediate_then_Mask_Insert
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_Immediate_then_Mask_Insert_Rc0

  /* extraction: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.M.RS /* in icache - extraction */
#define rS cache_entry->crack.M.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.M.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.M.RA /* in icache - extraction */
#define rA cache_entry->crack.M.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.M.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define SH cache_entry->crack.M.SH /* default in icache - extraction */
#define MB cache_entry->crack.M.MB /* default in icache - extraction */
#define ME cache_entry->crack.M.ME /* default in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 12734 "semantics.c"

#define insn cache_entry->crack.M.insn
  unsigned_word nia;
#line 3232 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Rotate Left Word Immediate then Mask Insert\n"));
#line 12740 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Rotate_Left_Word_Immediate_then_Mask_Insert, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3232 "../.././sim/ppc/ppc-instructions"
  {
    long n = SH;
    unsigned32 r = ROTL32(*rS, n);
    unsigned32 m = MASK(MB+32, ME+32);
    signed_word result = (r & m) | (*rA & ~m);
    *rA = result;
    ITRACE(trace_alu, (": n=%ld *rS=0x%lx r=0x%lx m=0x%lx result=0x%lx\n",
                       n, (unsigned long)*rS, (unsigned long)r, (unsigned long)m,
    		   (unsigned long)result));
    CR0_COMPARE(result, 0, Rc);
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 12762 "semantics.c"
  return nia;
  /* extraction: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef SH
#undef MB
#undef ME
#undef Rc
#line 12776 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Rotate_Left_Word_Immediate_then_Mask_Insert_Rc1(cpu *processor,
                                                         idecode_cache *cache_entry,
                                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_Immediate_then_Mask_Insert
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_Immediate_then_Mask_Insert_Rc1

  /* extraction: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.M.RS /* in icache - extraction */
#define rS cache_entry->crack.M.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.M.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.M.RA /* in icache - extraction */
#define rA cache_entry->crack.M.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.M.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define SH cache_entry->crack.M.SH /* default in icache - extraction */
#define MB cache_entry->crack.M.MB /* default in icache - extraction */
#define ME cache_entry->crack.M.ME /* default in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 12804 "semantics.c"

#define insn cache_entry->crack.M.insn
  unsigned_word nia;
#line 3232 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Rotate Left Word Immediate then Mask Insert\n"));
#line 12810 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Rotate_Left_Word_Immediate_then_Mask_Insert, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3232 "../.././sim/ppc/ppc-instructions"
  {
    long n = SH;
    unsigned32 r = ROTL32(*rS, n);
    unsigned32 m = MASK(MB+32, ME+32);
    signed_word result = (r & m) | (*rA & ~m);
    *rA = result;
    ITRACE(trace_alu, (": n=%ld *rS=0x%lx r=0x%lx m=0x%lx result=0x%lx\n",
                       n, (unsigned long)*rS, (unsigned long)r, (unsigned long)m,
    		   (unsigned long)result));
    CR0_COMPARE(result, 0, Rc);
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 12832 "semantics.c"
  return nia;
  /* extraction: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef SH
#undef MB
#undef ME
#undef Rc
#line 12846 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc0(cpu *processor,
                                                           idecode_cache *cache_entry,
                                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_Immediate_then_AND_with_Mask
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc0

  /* extraction: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.M.RS /* in icache - extraction */
#define rS cache_entry->crack.M.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.M.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.M.RA /* in icache - extraction */
#define rA cache_entry->crack.M.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.M.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define SH cache_entry->crack.M.SH /* default in icache - extraction */
#define MB cache_entry->crack.M.MB /* default in icache - extraction */
#define ME cache_entry->crack.M.ME /* default in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 12874 "semantics.c"

#define insn cache_entry->crack.M.insn
  unsigned_word nia;
#line 3179 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Rotate Left Word Immediate then AND with Mask\n"));
#line 12880 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Rotate_Left_Word_Immediate_then_AND_with_Mask, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3179 "../.././sim/ppc/ppc-instructions"
  {
    long n = SH;
    unsigned32 s = *rS;
    unsigned32 r = ROTL32(s, n);
    unsigned32 m = MASK(MB+32, ME+32);
    signed_word result = r & m;
    *rA = result;
    CR0_COMPARE(result, 0, Rc);
    ITRACE(trace_alu,
           ("n=%ld, s=0x%lx, r=0x%lx, m=0x%lx, result=0x%lx, cr=0x%lx\n",
            n, (unsigned long)s, (unsigned long)r, (unsigned long)m,
    	(unsigned long)result, (unsigned long)CR));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 12904 "semantics.c"
  return nia;
  /* extraction: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef SH
#undef MB
#undef ME
#undef Rc
#line 12918 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc1(cpu *processor,
                                                           idecode_cache *cache_entry,
                                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_Immediate_then_AND_with_Mask
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc1

  /* extraction: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.M.RS /* in icache - extraction */
#define rS cache_entry->crack.M.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.M.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.M.RA /* in icache - extraction */
#define rA cache_entry->crack.M.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.M.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define SH cache_entry->crack.M.SH /* default in icache - extraction */
#define MB cache_entry->crack.M.MB /* default in icache - extraction */
#define ME cache_entry->crack.M.ME /* default in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 12946 "semantics.c"

#define insn cache_entry->crack.M.insn
  unsigned_word nia;
#line 3179 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Rotate Left Word Immediate then AND with Mask\n"));
#line 12952 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Rotate_Left_Word_Immediate_then_AND_with_Mask, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3179 "../.././sim/ppc/ppc-instructions"
  {
    long n = SH;
    unsigned32 s = *rS;
    unsigned32 r = ROTL32(s, n);
    unsigned32 m = MASK(MB+32, ME+32);
    signed_word result = r & m;
    *rA = result;
    CR0_COMPARE(result, 0, Rc);
    ITRACE(trace_alu,
           ("n=%ld, s=0x%lx, r=0x%lx, m=0x%lx, result=0x%lx, cr=0x%lx\n",
            n, (unsigned long)s, (unsigned long)r, (unsigned long)m,
    	(unsigned long)result, (unsigned long)CR));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 12976 "semantics.c"
  return nia;
  /* extraction: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef SH
#undef MB
#undef ME
#undef Rc
#line 12990 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Rotate_Left_Word_then_AND_with_Mask_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_then_AND_with_Mask
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_then_AND_with_Mask_Rc0

  /* extraction: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.M.RS /* in icache - extraction */
#define rS cache_entry->crack.M.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.M.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.M.RA /* in icache - extraction */
#define rA cache_entry->crack.M.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.M.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.M.RB /* in icache - extraction */
#define rB cache_entry->crack.M.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.M.RB_BITMASK /* in icache - extraction */
#define MB cache_entry->crack.M.MB /* default in icache - extraction */
#define ME cache_entry->crack.M.ME /* default in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 13020 "semantics.c"

#define insn cache_entry->crack.M.insn
  unsigned_word nia;
#line 3211 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Rotate Left Word then AND with Mask\n"));
#line 13026 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Rotate_Left_Word_then_AND_with_Mask, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3211 "../.././sim/ppc/ppc-instructions"
  {
    long n = MASKED(*rB, 59, 63);
    unsigned32 r = ROTL32(*rS, n);
    unsigned32 m = MASK(MB+32, ME+32);
    signed_word result = r & m;
    *rA = result;
    CR0_COMPARE(result, 0, Rc);
  }
#line 13044 "semantics.c"
  return nia;
  /* extraction: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef MB
#undef ME
#undef Rc
#line 13060 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Rotate_Left_Word_then_AND_with_Mask_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_then_AND_with_Mask
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_then_AND_with_Mask_Rc1

  /* extraction: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.M.RS /* in icache - extraction */
#define rS cache_entry->crack.M.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.M.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.M.RA /* in icache - extraction */
#define rA cache_entry->crack.M.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.M.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.M.RB /* in icache - extraction */
#define rB cache_entry->crack.M.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.M.RB_BITMASK /* in icache - extraction */
#define MB cache_entry->crack.M.MB /* default in icache - extraction */
#define ME cache_entry->crack.M.ME /* default in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 13090 "semantics.c"

#define insn cache_entry->crack.M.insn
  unsigned_word nia;
#line 3211 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Rotate Left Word then AND with Mask\n"));
#line 13096 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Rotate_Left_Word_then_AND_with_Mask, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3211 "../.././sim/ppc/ppc-instructions"
  {
    long n = MASKED(*rB, 59, 63);
    unsigned32 r = ROTL32(*rS, n);
    unsigned32 m = MASK(MB+32, ME+32);
    signed_word result = r & m;
    *rA = result;
    CR0_COMPARE(result, 0, Rc);
  }
#line 13114 "semantics.c"
  return nia;
  /* extraction: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef MB
#undef ME
#undef Rc
#line 13130 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_OR_Immediate(cpu *processor,
                      idecode_cache *cache_entry,
                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_OR_Immediate
#undef MY_PREFIX
#define MY_PREFIX OR_Immediate

  /* extraction: 0.24,6.RS,11.RA,16.UI #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 13155 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2975 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics OR Immediate\n"));
#line 13161 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_OR_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2975 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS | UI;
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 0/*Rc*/);
  }
#line 13176 "semantics.c"
  return nia;
  /* extraction: 0.24,6.RS,11.RA,16.UI #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 13187 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_OR_Immediate_Shifted(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_OR_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX OR_Immediate_Shifted

  /* extraction: 0.25,6.RS,11.RA,16.UI #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 13212 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2984 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics OR Immediate Shifted\n"));
#line 13218 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_OR_Immediate_Shifted, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2984 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS | (UI << 16);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 0/*Rc*/);
  }
#line 13233 "semantics.c"
  return nia;
  /* extraction: 0.25,6.RS,11.RA,16.UI #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 13244 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_XOR_Immediate(cpu *processor,
                       idecode_cache *cache_entry,
                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_XOR_Immediate
#undef MY_PREFIX
#define MY_PREFIX XOR_Immediate

  /* extraction: 0.26,6.RS,11.RA,16.UI #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 13269 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2993 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics XOR Immediate\n"));
#line 13275 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_XOR_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2993 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS ^ UI;
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 0/*Rc*/);
  }
#line 13290 "semantics.c"
  return nia;
  /* extraction: 0.26,6.RS,11.RA,16.UI #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 13301 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_XOR_Immediate_Shifted(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_XOR_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX XOR_Immediate_Shifted

  /* extraction: 0.27,6.RS,11.RA,16.UI #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 13326 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3002 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics XOR Immediate Shifted\n"));
#line 13332 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_XOR_Immediate_Shifted, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3002 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS ^ (UI << 16);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 0/*Rc*/);
  }
#line 13347 "semantics.c"
  return nia;
  /* extraction: 0.27,6.RS,11.RA,16.UI #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 13358 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_AND_Immediate(cpu *processor,
                       idecode_cache *cache_entry,
                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_AND_Immediate
#undef MY_PREFIX
#define MY_PREFIX AND_Immediate

  /* extraction: 0.28,6.RS,11.RA,16.UI #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 13383 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2955 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics AND Immediate\n"));
#line 13389 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_AND_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2955 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS & UI;
    CR0_COMPARE(*rA, 0, 1/*Rc*/);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 1/*Rc*/);
  }
#line 13405 "semantics.c"
  return nia;
  /* extraction: 0.28,6.RS,11.RA,16.UI #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 13416 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_AND_Immediate_Shifted(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_AND_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX AND_Immediate_Shifted

  /* extraction: 0.29,6.RS,11.RA,16.UI #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 13441 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2965 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics AND Immediate Shifted\n"));
#line 13447 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_AND_Immediate_Shifted, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2965 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS & (UI << 16);
    CR0_COMPARE(*rA, 0, 1/*Rc*/);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 1/*Rc*/);
  }
#line 13463 "semantics.c"
  return nia;
  /* extraction: 0.29,6.RS,11.RA,16.UI #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 13474 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Compare(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Compare
#undef MY_PREFIX
#define MY_PREFIX Compare

  /* extraction: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.0,31./ #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define L cache_entry->crack.X.L /* default in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 13501 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2811 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Compare\n"));
#line 13507 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Compare, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2811 "../.././sim/ppc/ppc-instructions"
  {
    if (!is_64bit_mode && L)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      signed_word a;
      signed_word b;
      if (L == 0) {
        a = EXTENDED(*rA);
        b = EXTENDED(*rB);
      }
      else {
        a = *rA;
        b = *rB;
      }
      CR_COMPARE(BF, a, b);
    }
    PPC_INSN_INT_CR(0, RA_BITMASK | RB_BITMASK, BF_BITMASK);
  }
#line 13536 "semantics.c"
  return nia;
  /* extraction: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.0,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef L
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 13549 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Trap_Word(cpu *processor,
                   idecode_cache *cache_entry,
                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Trap_Word
#undef MY_PREFIX
#define MY_PREFIX Trap_Word

  /* extraction: 0.31,6.TO,11.RA,16.RB,21.4,31./ #define get-values-from-icache */
#define TO cache_entry->crack.X.TO /* default in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 13574 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2931 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Trap Word\n"));
#line 13580 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Trap_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2931 "../.././sim/ppc/ppc-instructions"
  {
    signed_word a = EXTENDED(*rA);
    signed_word b = EXTENDED(*rB);
    if (TO == 12 && rA == rB) {
      ITRACE(trace_breakpoint, ("breakpoint\n"));
      cpu_halt(processor, cia, was_trap, 0);
    }
    else if ((a < b && TO_0_)
        || (a > b && TO_1_)
        || (a == b && TO_2_)
        || ((unsigned_word)a < (unsigned_word)b && TO_3_)
        || ((unsigned_word)a > (unsigned_word)b && TO_4_)
        )
      program_interrupt(processor, cia,
                        trap_program_interrupt);
  }
#line 13606 "semantics.c"
  return nia;
  /* extraction: 0.31,6.TO,11.RA,16.RB,21.4,31./ #undef get-values-from-icache */
#undef TO
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 13617 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Carrying_OE0_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Carrying_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 13646 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2597 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Carrying\n"));
#line 13652 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2597 "../.././sim/ppc/ppc-instructions"
  {
    /* RT <- ~RA + RB + 1 === RT <- RB - RA */
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 13671 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 13686 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Carrying_OE0_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Carrying_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 13715 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2597 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Carrying\n"));
#line 13721 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2597 "../.././sim/ppc/ppc-instructions"
  {
    /* RT <- ~RA + RB + 1 === RT <- RB - RA */
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 13740 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 13755 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Carrying_OE0_Rc0(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Carrying_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 13784 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2587 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Carrying\n"));
#line 13790 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2587 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 13806 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 13821 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Carrying_OE0_Rc1(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Carrying_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 13850 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2587 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Carrying\n"));
#line 13856 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2587 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 13872 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 13887 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_High_Word_Unsigned_Rc0(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_High_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Multiply_High_Word_Unsigned_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 13915 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2731 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply High Word Unsigned\n"));
#line 13921 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_High_Word_Unsigned, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2731 "../.././sim/ppc/ppc-instructions"
  {
    unsigned64 a = (unsigned32)(*rA);
    unsigned64 b = (unsigned32)(*rB);
    unsigned64 prod = a * b;
    signed_word t = EXTRACTED64(prod, 0, 31);
    *rT = t;
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 13940 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 13954 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_High_Word_Unsigned_Rc1(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_High_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Multiply_High_Word_Unsigned_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 13982 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2731 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply High Word Unsigned\n"));
#line 13988 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_High_Word_Unsigned, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2731 "../.././sim/ppc/ppc-instructions"
  {
    unsigned64 a = (unsigned32)(*rA);
    unsigned64 b = (unsigned32)(*rB);
    unsigned64 prod = a * b;
    signed_word t = EXTRACTED64(prod, 0, 31);
    *rT = t;
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 14007 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 14021 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_Condition_Register(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Condition_Register
#undef MY_PREFIX
#define MY_PREFIX Move_From_Condition_Register

  /* extraction: 0.31,6.RT,11./,16./,21.19,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#line 14041 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3446 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From Condition Register\n"));
#line 14047 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_Condition_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3446 "../.././sim/ppc/ppc-instructions"
  {
    *rT = (unsigned32)CR;
    PPC_INSN_MFCR(RT_BITMASK);
  }
#line 14061 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11./,16./,21.19,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#line 14067 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Word_And_Reserve_Indexed(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_And_Reserve_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Word_And_Reserve_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.20,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 14094 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2423 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Word And Reserve Indexed\n"));
#line 14100 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Word_And_Reserve_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2423 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    RESERVE = 1;
    RESERVE_ADDR = real_addr(EA, 1/*is-read?*/);
    RESERVE_DATA = MEM(unsigned, EA, 4);
    *rT = RESERVE_DATA;
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 14122 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.20,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 14135 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Word_and_Zero_Indexed(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_and_Zero_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Word_and_Zero_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.23,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 14162 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1899 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Word and Zero Indexed\n"));
#line 14168 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Word_and_Zero_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1899 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *rT = MEM(unsigned, EA, 4);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 14187 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.23,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 14200 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Left_Word_Rc0(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Left_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Left_Word_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 14228 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3251 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Left Word\n"));
#line 14234 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Left_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3251 "../.././sim/ppc/ppc-instructions"
  {
    int n = MASKED(*rB, 58, 63);
    unsigned32 source = *rS;
    signed_word shifted;
    if (n < 32)
      shifted = (source << n);
    else
      shifted = 0;
    *rA = shifted;
    CR0_COMPARE(shifted, 0, Rc);
    ITRACE(trace_alu,
           ("n=%d, source=0x%lx, shifted=0x%lx\n",
            n, (unsigned long)source, (unsigned long)shifted));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 14259 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 14273 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Left_Word_Rc1(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Left_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Left_Word_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 14301 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3251 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Left Word\n"));
#line 14307 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Left_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3251 "../.././sim/ppc/ppc-instructions"
  {
    int n = MASKED(*rB, 58, 63);
    unsigned32 source = *rS;
    signed_word shifted;
    if (n < 32)
      shifted = (source << n);
    else
      shifted = 0;
    *rA = shifted;
    CR0_COMPARE(shifted, 0, Rc);
    ITRACE(trace_alu,
           ("n=%d, source=0x%lx, shifted=0x%lx\n",
            n, (unsigned long)source, (unsigned long)shifted));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 14332 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 14346 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Count_Leading_Zeros_Word_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Count_Leading_Zeros_Word
#undef MY_PREFIX
#define MY_PREFIX Count_Leading_Zeros_Word_Rc0

  /* extraction: 0.31,6.RS,11.RA,16./,21.26,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define Rc 0 /* default in icache - constant field */
#line 14371 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3130 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Count Leading Zeros Word\n"));
#line 14377 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Count_Leading_Zeros_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3130 "../.././sim/ppc/ppc-instructions"
  {
    int count = 0;
    unsigned32 mask = BIT32(0);
    unsigned32 source = *rS;
    while (!(source & mask) && mask != 0) {
      mask >>= 1;
      count++;
    }
    *rA = count;
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    CR0_COMPARE(count, 0, Rc); /* FIXME - is this correct */
  }
#line 14399 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16./,21.26,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef Rc
#line 14410 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Count_Leading_Zeros_Word_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Count_Leading_Zeros_Word
#undef MY_PREFIX
#define MY_PREFIX Count_Leading_Zeros_Word_Rc1

  /* extraction: 0.31,6.RS,11.RA,16./,21.26,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define Rc 1 /* default in icache - constant field */
#line 14435 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3130 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Count Leading Zeros Word\n"));
#line 14441 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Count_Leading_Zeros_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3130 "../.././sim/ppc/ppc-instructions"
  {
    int count = 0;
    unsigned32 mask = BIT32(0);
    unsigned32 source = *rS;
    while (!(source & mask) && mask != 0) {
      mask >>= 1;
      count++;
    }
    *rA = count;
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    CR0_COMPARE(count, 0, Rc); /* FIXME - is this correct */
  }
#line 14463 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16./,21.26,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef Rc
#line 14474 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_AND_Rc0(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_AND
#undef MY_PREFIX
#define MY_PREFIX AND_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 14502 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3011 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics AND\n"));
#line 14508 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_AND, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3011 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS & *rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 14524 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 14538 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_AND_Rc1(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_AND
#undef MY_PREFIX
#define MY_PREFIX AND_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 14566 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3011 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics AND\n"));
#line 14572 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_AND, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3011 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS & *rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 14588 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 14602 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Compare_Logical(cpu *processor,
                         idecode_cache *cache_entry,
                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Compare_Logical
#undef MY_PREFIX
#define MY_PREFIX Compare_Logical

  /* extraction: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.32,31./ #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define L cache_entry->crack.X.L /* default in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 14629 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2853 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Compare Logical\n"));
#line 14635 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Compare_Logical, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2853 "../.././sim/ppc/ppc-instructions"
  {
    if (!is_64bit_mode && L)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      unsigned_word a;
      unsigned_word b;
      if (L == 0) {
        a = MASKED(*rA, 32, 63);
        b = MASKED(*rB, 32, 63);
      }
      else {
        a = *rA;
        b = *rB;
      }
      CR_COMPARE(BF, a, b);
    }
    PPC_INSN_INT_CR(0, RA_BITMASK | RB_BITMASK, BF_BITMASK);
  }
#line 14664 "semantics.c"
  return nia;
  /* extraction: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.32,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef L
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 14677 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_OE0_Rc0(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 14706 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2543 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From\n"));
#line 14712 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2543 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 14730 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 14745 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_OE0_Rc1(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 14774 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2543 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From\n"));
#line 14780 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2543 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 14798 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 14813 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Data_Cache_Block_Store(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Store
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Store

  /* extraction: 0.31,6./,11.RA,16.RB,21.54,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 14837 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4789 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Data Cache Block Store\n"));
#line 14843 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Data_Cache_Block_Store, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4789 "../.././sim/ppc/ppc-instructions"
  {
    TRACE(trace_tbd,("Data Cache Block Store\n"));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
  }
#line 14857 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.54,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 14867 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Word_and_Zero_with_Update_Indexed(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_and_Zero_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Word_and_Zero_with_Update_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.55,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 14894 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1926 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Word and Zero with Update Indexed\n"));
#line 14900 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Word_and_Zero_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1926 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    *rT = MEM(unsigned, EA, 4);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK | RB_BITMASK, 0);
  }
#line 14920 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.55,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 14933 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_AND_with_Complement_Rc0(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_AND_with_Complement
#undef MY_PREFIX
#define MY_PREFIX AND_with_Complement_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 14961 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3071 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics AND with Complement\n"));
#line 14967 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_AND_with_Complement, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3071 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS & ~*rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 14983 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 14997 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_AND_with_Complement_Rc1(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_AND_with_Complement
#undef MY_PREFIX
#define MY_PREFIX AND_with_Complement_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 15025 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3071 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics AND with Complement\n"));
#line 15031 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_AND_with_Complement, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3071 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS & ~*rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 15047 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 15061 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_High_Word_Rc0(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_High_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_High_Word_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 15089 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2716 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply High Word\n"));
#line 15095 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_High_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2716 "../.././sim/ppc/ppc-instructions"
  {
    signed64 a = (signed32)(*rA);
    signed64 b = (signed32)(*rB);
    signed64 prod = a * b;
    signed_word t = EXTRACTED64(prod, 0, 31);
    *rT = t;
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 15114 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 15128 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_High_Word_Rc1(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_High_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_High_Word_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 15156 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2716 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply High Word\n"));
#line 15162 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_High_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2716 "../.././sim/ppc/ppc-instructions"
  {
    signed64 a = (signed32)(*rA);
    signed64 b = (signed32)(*rB);
    signed64 prod = a * b;
    signed_word t = EXTRACTED64(prod, 0, 31);
    *rT = t;
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 15181 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 15195 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_Machine_State_Register(cpu *processor,
                                          idecode_cache *cache_entry,
                                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Machine_State_Register
#undef MY_PREFIX
#define MY_PREFIX Move_From_Machine_State_Register

  /* extraction: 0.31,6.RT,11./,16./,21.83,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#line 15215 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4876 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From Machine State Register\n"));
#line 15221 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_Machine_State_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4876 "../.././sim/ppc/ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else {
      *rT = MSR;
      check_masked_interrupts(processor);
    }
  }
#line 15240 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11./,16./,21.83,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#line 15246 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Data_Cache_Block_Flush(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Flush
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Flush

  /* extraction: 0.31,6./,11.RA,16.RB,21.86,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 15270 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4797 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Data Cache Block Flush\n"));
#line 15276 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Data_Cache_Block_Flush, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4797 "../.././sim/ppc/ppc-instructions"
  {
    TRACE(trace_tbd,("Data Cache Block Flush\n"));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
  }
#line 15290 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.86,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 15300 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Byte_and_Zero_Indexed(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Byte_and_Zero_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Byte_and_Zero_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.87,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 15327 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1737 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Byte and Zero Indexed\n"));
#line 15333 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Byte_and_Zero_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1737 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *rT = MEM(unsigned, EA, 1);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 15352 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.87,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 15365 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Negate_OE0_Rc0(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Negate
#undef MY_PREFIX
#define MY_PREFIX Negate_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 15391 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2677 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Negate\n"));
#line 15397 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Negate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2677 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(1);
    ALU_END(*rT,0/*CA*/,OE,Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 15414 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 15426 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Negate_OE0_Rc1(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Negate
#undef MY_PREFIX
#define MY_PREFIX Negate_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 15452 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2677 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Negate\n"));
#line 15458 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Negate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2677 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(1);
    ALU_END(*rT,0/*CA*/,OE,Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 15475 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 15487 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Byte_and_Zero_with_Update_Indexed(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Byte_and_Zero_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Byte_and_Zero_with_Update_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.119,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 15514 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1764 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Byte and Zero with Update Indexed\n"));
#line 15520 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Byte_and_Zero_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1764 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    *rT = MEM(unsigned, EA, 1);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK | RB_BITMASK, 0);
  }
#line 15540 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.119,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 15553 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_NOR_Rc0(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_NOR
#undef MY_PREFIX
#define MY_PREFIX NOR_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 15581 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3051 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics NOR\n"));
#line 15587 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_NOR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3051 "../.././sim/ppc/ppc-instructions"
  {
    *rA = ~(*rS | *rB);
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 15603 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 15617 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_NOR_Rc1(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_NOR
#undef MY_PREFIX
#define MY_PREFIX NOR_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 15645 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3051 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics NOR\n"));
#line 15651 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_NOR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3051 "../.././sim/ppc/ppc-instructions"
  {
    *rA = ~(*rS | *rB);
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 15667 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 15681 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Extended_OE0_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Extended_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 15710 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2621 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Extended\n"));
#line 15716 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2621 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 15734 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 15749 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Extended_OE0_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Extended_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 15778 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2621 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Extended\n"));
#line 15784 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2621 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 15802 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 15817 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Extended_OE0_Rc0(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_Extended_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 15846 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2610 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Extended\n"));
#line 15852 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2610 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 15869 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 15884 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Extended_OE0_Rc1(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_Extended_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 15913 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2610 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Extended\n"));
#line 15919 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2610 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 15936 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 15951 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_to_Condition_Register_Fields(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Condition_Register_Fields
#undef MY_PREFIX
#define MY_PREFIX Move_to_Condition_Register_Fields

  /* extraction: 0.31,6.RS,11./,12.FXM,20./,21.144,31./ #define get-values-from-icache */
#define RS cache_entry->crack.XFX.RS /* in icache - extraction */
#define rS cache_entry->crack.XFX.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.XFX.RS_BITMASK /* in icache - extraction */
#define FXM cache_entry->crack.XFX.FXM /* default in icache - extraction */
#line 15972 "semantics.c"

#define insn cache_entry->crack.XFX.insn
  unsigned_word nia;
#line 3423 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move to Condition Register Fields\n"));
#line 15978 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_to_Condition_Register_Fields, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3423 "../.././sim/ppc/ppc-instructions"
  {
    if (FXM == 0xff) {
      CR = *rS;
    }
    else {
      unsigned_word mask = 0;
      unsigned_word f;
      for (f = 0; f < 8; f++) {
        if (FXM & (0x80 >> f))
          mask |= (0xf << 4*(7-f));
      }
      CR = (MASKED(*rS, 32, 63) & mask) | (CR & ~mask);
    }
    PPC_INSN_MTCR(RS_BITMASK, FXM);
  }
#line 16003 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11./,12.FXM,20./,21.144,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef FXM
#line 16010 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_Machine_State_Register(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_Machine_State_Register
#undef MY_PREFIX
#define MY_PREFIX Move_To_Machine_State_Register

  /* extraction: 0.31,6.RS,11./,16./,21.146,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#line 16030 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4863 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To Machine State Register\n"));
#line 16036 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_Machine_State_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4863 "../.././sim/ppc/ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else {
      MSR = *rS;
      check_masked_interrupts(processor);
    }
  }
#line 16055 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11./,16./,21.146,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#line 16061 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Word_Conditional_Indexed(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_Conditional_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Word_Conditional_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.150,31.1 #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 16088 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2451 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Word Conditional Indexed\n"));
#line 16094 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Word_Conditional_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2451 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    if (RESERVE) {
      if (RESERVE_ADDR == real_addr(EA, 0/*is-read?*/)
          && /*HACK*/ RESERVE_DATA == MEM(unsigned, EA, 4)) {
        STORE(EA, 4, *rS);
        CR_SET_XER_SO(0, cr_i_zero);
      }
      else {
        /* ment to randomly to store, we never do! */	
        CR_SET_XER_SO(0, 0);
      }
      RESERVE = 0;
    }
    else {
      CR_SET_XER_SO(0, 0);
    }
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 1/*Rc*/);
  }
#line 16127 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.150,31.1 #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 16140 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Word_Indexed(cpu *processor,
                            idecode_cache *cache_entry,
                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Word_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.151,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 16167 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2126 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Word Indexed\n"));
#line 16173 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Word_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2126 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 4, *rS);
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
  }
#line 16192 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.151,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 16205 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Word_with_Update_Indexed(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Word_with_Update_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.183,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 16232 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2153 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Word with Update Indexed\n"));
#line 16238 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Word_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2153 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    STORE(EA, 4, *rS);
    *rA = EA;
    PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RB_BITMASK | RS_BITMASK, 0);
  }
#line 16258 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.183,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 16271 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_from_Zero_Extended_OE0_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_from_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_from_Zero_Extended_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 16297 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2666 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract from Zero Extended\n"));
#line 16303 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_from_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2666 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16320 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16332 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_from_Zero_Extended_OE0_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_from_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_from_Zero_Extended_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 16358 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2666 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract from Zero Extended\n"));
#line 16364 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_from_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2666 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16381 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16393 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Zero_Extended_OE0_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Zero_Extended_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 16419 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2656 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Zero Extended\n"));
#line 16425 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2656 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16441 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16453 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Zero_Extended_OE0_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Zero_Extended_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 16479 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2656 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Zero Extended\n"));
#line 16485 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2656 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16501 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16513 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_Segment_Register(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_Segment_Register
#undef MY_PREFIX
#define MY_PREFIX Move_To_Segment_Register

  /* extraction: 0.31,6.RS,11./,12.SR,16./,21.210,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define SR cache_entry->crack.X.SR /* default in icache - extraction */
#line 16534 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4909 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To Segment Register\n"));
#line 16540 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_Segment_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4909 "../.././sim/ppc/ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else
      SEGREG(SR) = *rS;
  }
#line 16557 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11./,12.SR,16./,21.210,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef SR
#line 16564 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Byte_Indexed(cpu *processor,
                            idecode_cache *cache_entry,
                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Byte_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Byte_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.215,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 16591 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2018 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Byte Indexed\n"));
#line 16597 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Byte_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2018 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 1, *rS);
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
  }
#line 16616 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.215,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 16629 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Minus_One_Extended_OE0_Rc0(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Minus_One_Extended_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 16655 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2644 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Minus One Extended\n"));
#line 16661 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2644 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16679 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16691 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Minus_One_Extended_OE0_Rc1(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Minus_One_Extended_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 16717 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2644 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Minus One Extended\n"));
#line 16723 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2644 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16741 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16753 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Minus_One_Extended_OE0_Rc0(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Minus_One_Extended_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 16779 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2633 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Minus One Extended\n"));
#line 16785 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2633 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16802 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16814 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Minus_One_Extended_OE0_Rc1(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Minus_One_Extended_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 16840 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2633 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Minus One Extended\n"));
#line 16846 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2633 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16863 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16875 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_Low_Word_OE0_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Word_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 16904 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2699 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply Low Word\n"));
#line 16910 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_Low_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2699 "../.././sim/ppc/ppc-instructions"
  {
    signed64 a = (signed32)(*rA);
    signed64 b = (signed32)(*rB);
    signed64 prod = a * b;
    signed_word t = prod;
    *rT = *rA * *rB;
    if (t != prod && OE)
      XER |= (xer_overflow | xer_summary_overflow);
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 16931 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 16946 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_Low_Word_OE0_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Word_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 16975 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2699 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply Low Word\n"));
#line 16981 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_Low_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2699 "../.././sim/ppc/ppc-instructions"
  {
    signed64 a = (signed32)(*rA);
    signed64 b = (signed32)(*rB);
    signed64 prod = a * b;
    signed_word t = prod;
    *rT = *rA * *rB;
    if (t != prod && OE)
      XER |= (xer_overflow | xer_summary_overflow);
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 17002 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 17017 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_Segment_Register_Indirect(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_Segment_Register_Indirect
#undef MY_PREFIX
#define MY_PREFIX Move_To_Segment_Register_Indirect

  /* extraction: 0.31,6.RS,11./,16.RB,21.242,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17040 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4920 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To Segment Register Indirect\n"));
#line 17046 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_Segment_Register_Indirect, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4920 "../.././sim/ppc/ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else
      SEGREG(EXTRACTED32(*rB, 0, 3)) = *rS;
  }
#line 17063 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11./,16.RB,21.242,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RB
#undef rB
#undef RB_BITMASK
#line 17072 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Data_Cache_Block_Touch_for_Store(cpu *processor,
                                          idecode_cache *cache_entry,
                                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Touch_for_Store
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Touch_for_Store

  /* extraction: 0.31,6./,11.RA,16.RB,21.246,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17096 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4773 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Data Cache Block Touch for Store\n"));
#line 17102 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Data_Cache_Block_Touch_for_Store, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4773 "../.././sim/ppc/ppc-instructions"
  {
    TRACE(trace_tbd,("Data Cache Block Touch for Store\n"));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
  }
#line 17116 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.246,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 17126 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Byte_with_Update_Indexed(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Byte_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Byte_with_Update_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.247,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17153 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2045 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Byte with Update Indexed\n"));
#line 17159 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Byte_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2045 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    STORE(EA, 1, *rS);
    *rA = EA;
    PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RB_BITMASK | RS_BITMASK, 0);
  }
#line 17179 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.247,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 17192 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_OE0_Rc0(cpu *processor,
                     idecode_cache *cache_entry,
                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add
#undef MY_PREFIX
#define MY_PREFIX Add_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 17221 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2533 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add\n"));
#line 17227 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2533 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 17243 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 17258 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_OE0_Rc1(cpu *processor,
                     idecode_cache *cache_entry,
                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add
#undef MY_PREFIX
#define MY_PREFIX Add_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 17287 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2533 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add\n"));
#line 17293 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2533 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 17309 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 17324 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Data_Cache_Block_Touch(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Touch
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Touch

  /* extraction: 0.31,6./,11.RA,16.RB,21.278,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17348 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4765 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Data Cache Block Touch\n"));
#line 17354 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Data_Cache_Block_Touch, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4765 "../.././sim/ppc/ppc-instructions"
  {
    TRACE(trace_tbd,("Data Cache Block Touch\n"));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
  }
#line 17368 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.278,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 17378 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_and_Zero_Indexed(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_and_Zero_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_and_Zero_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.279,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17405 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1791 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword and Zero Indexed\n"));
#line 17411 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_and_Zero_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1791 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *rT = MEM(unsigned, EA, 2);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 17430 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.279,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 17443 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Equivalent_Rc0(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Equivalent
#undef MY_PREFIX
#define MY_PREFIX Equivalent_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 17471 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3061 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Equivalent\n"));
#line 17477 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Equivalent, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3061 "../.././sim/ppc/ppc-instructions"
  {
    *rA = ~(*rS ^ *rB); /* A === B */
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 17493 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 17507 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Equivalent_Rc1(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Equivalent
#undef MY_PREFIX
#define MY_PREFIX Equivalent_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 17535 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3061 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Equivalent\n"));
#line 17541 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Equivalent, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3061 "../.././sim/ppc/ppc-instructions"
  {
    *rA = ~(*rS ^ *rB); /* A === B */
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 17557 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 17571 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_TLB_Invalidate_Entry(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_TLB_Invalidate_Entry
#undef MY_PREFIX
#define MY_PREFIX TLB_Invalidate_Entry

  /* extraction: 0.31,6./,11./,16.RB,21.306,31./ #define get-values-from-icache */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17591 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4958 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics TLB Invalidate Entry\n"));
#line 17597 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_TLB_Invalidate_Entry, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4958 "../.././sim/ppc/ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else {
      int nr = 0;
      cpu *proc;
      while (1) {
        proc = psim_cpu(cpu_system(processor), nr);
        if (proc == NULL) break;
        cpu_page_tlb_invalidate_entry(proc, *rB);
        nr++;
      }
    }
  }
#line 17622 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11./,16.RB,21.306,31./ #undef get-values-from-icache */
#undef RB
#undef rB
#undef RB_BITMASK
#line 17628 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_and_Zero_with_Update_Indexed(cpu *processor,
                                                    idecode_cache *cache_entry,
                                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_and_Zero_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_and_Zero_with_Update_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.311,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17655 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1818 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword and Zero with Update Indexed\n"));
#line 17661 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_and_Zero_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1818 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    *rT = MEM(unsigned, EA, 2);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK | RB_BITMASK, 0);
  }
#line 17681 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.311,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 17694 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_XOR_Rc0(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_XOR
#undef MY_PREFIX
#define MY_PREFIX XOR_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 17722 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3031 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics XOR\n"));
#line 17728 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_XOR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3031 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS ^ *rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 17744 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 17758 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_XOR_Rc1(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_XOR
#undef MY_PREFIX
#define MY_PREFIX XOR_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 17786 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3031 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics XOR\n"));
#line 17792 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_XOR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3031 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS ^ *rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 17808 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 17822 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_from_Special_Purpose_Register_SPR256(cpu *processor,
                                                   idecode_cache *cache_entry,
                                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_from_Special_Purpose_Register
#undef MY_PREFIX
#define MY_PREFIX Move_from_Special_Purpose_Register_SPR256

  /* extraction: 0.31,6.RT,11.SPR,21.339,31./ #define get-values-from-icache */
#define RT cache_entry->crack.XFX.RT /* in icache - extraction */
#define rT cache_entry->crack.XFX.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XFX.RT_BITMASK /* in icache - extraction */
#define SPR 256 /* default in icache - constant field */
#line 17843 "semantics.c"

#define insn cache_entry->crack.XFX.insn
  unsigned_word nia;
#line 3390 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move from Special Purpose Register\n"));
#line 17849 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_from_Special_Purpose_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3390 "../.././sim/ppc/ppc-instructions"
  {
    int n = (SPR_5_9_ << 5) | SPR_0_4_;
    if (SPR_0_ && IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else if (!spr_is_valid(n))
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      /* HACK - time base registers need to be calculated */
      if (WITH_TIME_BASE) {
        switch (n) {
        case spr_dec:
          *rT = cpu_get_decrementer(processor);
          break;
        case spr_tbu:
        case spr_tbl:
          /* NOTE - these SPR's are not readable. Use mftb[ul] */
        default:
          *rT = SPREG(n);
          break;
        }
      }
      else {
        *rT = SPREG(n);
      }
    }
    PPC_INSN_FROM_SPR(RT_BITMASK, n);
  }
#line 17888 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.SPR,21.339,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef SPR
#line 17895 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_from_Special_Purpose_Register_SPR(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_from_Special_Purpose_Register
#undef MY_PREFIX
#define MY_PREFIX Move_from_Special_Purpose_Register_SPR

  /* extraction: 0.31,6.RT,11.SPR,21.339,31./ #define get-values-from-icache */
#define RT cache_entry->crack.XFX.RT /* in icache - extraction */
#define rT cache_entry->crack.XFX.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XFX.RT_BITMASK /* in icache - extraction */
#define SPR cache_entry->crack.XFX.SPR /* default in icache - extraction */
#line 17916 "semantics.c"

#define insn cache_entry->crack.XFX.insn
  unsigned_word nia;
#line 3390 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move from Special Purpose Register\n"));
#line 17922 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_from_Special_Purpose_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3390 "../.././sim/ppc/ppc-instructions"
  {
    int n = (SPR_5_9_ << 5) | SPR_0_4_;
    if (SPR_0_ && IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else if (!spr_is_valid(n))
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      /* HACK - time base registers need to be calculated */
      if (WITH_TIME_BASE) {
        switch (n) {
        case spr_dec:
          *rT = cpu_get_decrementer(processor);
          break;
        case spr_tbu:
        case spr_tbl:
          /* NOTE - these SPR's are not readable. Use mftb[ul] */
        default:
          *rT = SPREG(n);
          break;
        }
      }
      else {
        *rT = SPREG(n);
      }
    }
    PPC_INSN_FROM_SPR(RT_BITMASK, n);
  }
#line 17961 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.SPR,21.339,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef SPR
#line 17968 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_Algebraic_Indexed(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_Algebraic_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_Algebraic_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.343,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17995 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1845 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword Algebraic Indexed\n"));
#line 18001 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_Algebraic_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1845 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *rT = MEM(signed, EA, 2);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 18020 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.343,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 18033 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_TLB_Invalidate_All(cpu *processor,
                            idecode_cache *cache_entry,
                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_TLB_Invalidate_All
#undef MY_PREFIX
#define MY_PREFIX TLB_Invalidate_All

  /* extraction: 0.31,6./,11./,16./,21.370,31./ #define get-values-from-icache */
#line 18050 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4973 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics TLB Invalidate All\n"));
#line 18056 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_TLB_Invalidate_All, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4973 "../.././sim/ppc/ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else {
      int nr = 0;
      cpu *proc;
      while (1) {
        proc = psim_cpu(cpu_system(processor), nr);
        if (proc == NULL) break;
        cpu_page_tlb_invalidate_all(proc);
        nr++;
      }
    }
  }
#line 18081 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11./,16./,21.370,31./ #undef get-values-from-icache */
#line 18084 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_Time_Base(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Time_Base
#undef MY_PREFIX
#define MY_PREFIX Move_From_Time_Base

  /* extraction: 0.31,6.RT,11.tbr,21.371,31./ #define get-values-from-icache */
#define RT cache_entry->crack.XFX.RT /* in icache - extraction */
#define rT cache_entry->crack.XFX.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XFX.RT_BITMASK /* in icache - extraction */
#define tbr cache_entry->crack.XFX.tbr /* default in icache - extraction */
#line 18105 "semantics.c"

#define insn cache_entry->crack.XFX.insn
  unsigned_word nia;
#line 4816 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From Time Base\n"));
#line 18111 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_Time_Base, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4816 "../.././sim/ppc/ppc-instructions"
  {
    int n = (tbr_5_9_ << 5) | tbr_0_4_;
    if (n == 268) {
      if (is_64bit_implementation) *rT = TB;
      else                         *rT = EXTRACTED64(TB, 32, 63);
    }
    else if (n == 269) {
      if (is_64bit_implementation) *rT = EXTRACTED64(TB, 0, 31);
      else                         *rT = EXTRACTED64(TB, 0, 31);
    }
    else
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
  }
#line 18135 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.tbr,21.371,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef tbr
#line 18142 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_Algebraic_with_Update_Indexed(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_Algebraic_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_Algebraic_with_Update_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.375,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 18169 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1872 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword Algebraic with Update Indexed\n"));
#line 18175 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_Algebraic_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1872 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    *rT = MEM(signed, EA, 2);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK | RB_BITMASK, 0);
  }
#line 18195 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.375,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 18208 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Half_Word_Indexed(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.407,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 18235 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2072 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Half Word Indexed\n"));
#line 18241 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Half_Word_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2072 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 2, *rS);
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
  }
#line 18260 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.407,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 18273 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_OR_with_Complement_Rc0(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_OR_with_Complement
#undef MY_PREFIX
#define MY_PREFIX OR_with_Complement_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 18301 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3081 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics OR with Complement\n"));
#line 18307 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_OR_with_Complement, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3081 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS | ~*rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 18323 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 18337 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_OR_with_Complement_Rc1(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_OR_with_Complement
#undef MY_PREFIX
#define MY_PREFIX OR_with_Complement_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 18365 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3081 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics OR with Complement\n"));
#line 18371 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_OR_with_Complement, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3081 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS | ~*rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 18387 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 18401 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Half_Word_with_Update_Indexed(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word_with_Update_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.439,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 18428 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2099 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Half Word with Update Indexed\n"));
#line 18434 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Half_Word_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2099 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    STORE(EA, 2, *rS);
    *rA = EA;
    PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RB_BITMASK | RS_BITMASK, 0);
  }
#line 18454 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.439,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 18467 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_OR_Rc0(cpu *processor,
                idecode_cache *cache_entry,
                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_OR
#undef MY_PREFIX
#define MY_PREFIX OR_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 18495 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3021 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics OR\n"));
#line 18501 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_OR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3021 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS | *rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 18517 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 18531 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_OR_Rc1(cpu *processor,
                idecode_cache *cache_entry,
                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_OR
#undef MY_PREFIX
#define MY_PREFIX OR_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 18559 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3021 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics OR\n"));
#line 18565 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_OR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3021 "../.././sim/ppc/ppc-instructions"
  {
    *rA = *rS | *rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 18581 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 18595 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_Unsigned_OE0_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_Unsigned_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 18624 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2768 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word Unsigned\n"));
#line 18630 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word_Unsigned, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2768 "../.././sim/ppc/ppc-instructions"
  {
    unsigned64 dividend = (unsigned32)(*rA);
    unsigned64 divisor = (unsigned32)(*rB);
    if (divisor == 0) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      unsigned64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 18655 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 18670 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_Unsigned_OE0_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_Unsigned_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 18699 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2768 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word Unsigned\n"));
#line 18705 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word_Unsigned, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2768 "../.././sim/ppc/ppc-instructions"
  {
    unsigned64 dividend = (unsigned32)(*rA);
    unsigned64 divisor = (unsigned32)(*rB);
    if (divisor == 0) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      unsigned64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 18730 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 18745 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_to_Special_Purpose_Register_SPR256(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Special_Purpose_Register
#undef MY_PREFIX
#define MY_PREFIX Move_to_Special_Purpose_Register_SPR256

  /* extraction: 0.31,6.RS,11.SPR,21.467,31./ #define get-values-from-icache */
#define RS cache_entry->crack.XFX.RS /* in icache - extraction */
#define rS cache_entry->crack.XFX.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.XFX.RS_BITMASK /* in icache - extraction */
#define SPR 256 /* default in icache - constant field */
#line 18766 "semantics.c"

#define insn cache_entry->crack.XFX.insn
  unsigned_word nia;
#line 3346 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move to Special Purpose Register\n"));
#line 18772 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_to_Special_Purpose_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3346 "../.././sim/ppc/ppc-instructions"
  {
    int n = (SPR_5_9_ << 5) | SPR_0_4_;
    if (SPR_0_ && IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else if (!spr_is_valid(n)
             || spr_is_readonly(n))
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      spreg new_val = (spr_length(n) == 64
    		   ? *rS
    		   : MASKED(*rS, 32, 63));
      /* HACK - time base registers need to be updated immediatly */
      if (WITH_TIME_BASE) {
        switch (n) {
        case spr_tbu:
          cpu_set_time_base(processor,
                            (MASKED64(cpu_get_time_base(processor), 32, 63)
                             | INSERTED64(new_val, 0, 31)));
          break;
        case spr_tbl:
          cpu_set_time_base(processor,
                            (MASKED64(cpu_get_time_base(processor), 0, 31)
                             | INSERTED64(new_val, 32, 63)));
          break;
        case spr_dec:
          cpu_set_decrementer(processor, new_val);
          break;
        default:
          SPREG(n) = new_val;
          break;
        }
      }
      else {
        SPREG(n) = new_val;
      }
    }
    PPC_INSN_TO_SPR(RS_BITMASK, n);
  }
#line 18822 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.SPR,21.467,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef SPR
#line 18829 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_to_Special_Purpose_Register_SPR(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Special_Purpose_Register
#undef MY_PREFIX
#define MY_PREFIX Move_to_Special_Purpose_Register_SPR

  /* extraction: 0.31,6.RS,11.SPR,21.467,31./ #define get-values-from-icache */
#define RS cache_entry->crack.XFX.RS /* in icache - extraction */
#define rS cache_entry->crack.XFX.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.XFX.RS_BITMASK /* in icache - extraction */
#define SPR cache_entry->crack.XFX.SPR /* default in icache - extraction */
#line 18850 "semantics.c"

#define insn cache_entry->crack.XFX.insn
  unsigned_word nia;
#line 3346 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move to Special Purpose Register\n"));
#line 18856 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_to_Special_Purpose_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3346 "../.././sim/ppc/ppc-instructions"
  {
    int n = (SPR_5_9_ << 5) | SPR_0_4_;
    if (SPR_0_ && IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else if (!spr_is_valid(n)
             || spr_is_readonly(n))
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      spreg new_val = (spr_length(n) == 64
    		   ? *rS
    		   : MASKED(*rS, 32, 63));
      /* HACK - time base registers need to be updated immediatly */
      if (WITH_TIME_BASE) {
        switch (n) {
        case spr_tbu:
          cpu_set_time_base(processor,
                            (MASKED64(cpu_get_time_base(processor), 32, 63)
                             | INSERTED64(new_val, 0, 31)));
          break;
        case spr_tbl:
          cpu_set_time_base(processor,
                            (MASKED64(cpu_get_time_base(processor), 0, 31)
                             | INSERTED64(new_val, 32, 63)));
          break;
        case spr_dec:
          cpu_set_decrementer(processor, new_val);
          break;
        default:
          SPREG(n) = new_val;
          break;
        }
      }
      else {
        SPREG(n) = new_val;
      }
    }
    PPC_INSN_TO_SPR(RS_BITMASK, n);
  }
#line 18906 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.SPR,21.467,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef SPR
#line 18913 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Data_Cache_Block_Invalidate(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Invalidate
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Invalidate

  /* extraction: 0.31,6./,11.RA,16.RB,21.470,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 18937 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4894 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Data Cache Block Invalidate\n"));
#line 18943 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Data_Cache_Block_Invalidate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4894 "../.././sim/ppc/ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else
      TRACE(trace_tbd,("Data Cache Block Invalidate\n"));
  }
#line 18960 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.470,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 18970 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_NAND_Rc0(cpu *processor,
                  idecode_cache *cache_entry,
                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_NAND
#undef MY_PREFIX
#define MY_PREFIX NAND_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 18998 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3041 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics NAND\n"));
#line 19004 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_NAND, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3041 "../.././sim/ppc/ppc-instructions"
  {
    *rA = ~(*rS & *rB);
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 19020 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 19034 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_NAND_Rc1(cpu *processor,
                  idecode_cache *cache_entry,
                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_NAND
#undef MY_PREFIX
#define MY_PREFIX NAND_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 19062 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3041 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics NAND\n"));
#line 19068 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_NAND, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3041 "../.././sim/ppc/ppc-instructions"
  {
    *rA = ~(*rS & *rB);
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 19084 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 19098 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_OE0_Rc0(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 19127 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2746 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word\n"));
#line 19133 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2746 "../.././sim/ppc/ppc-instructions"
  {
    signed64 dividend = (signed32)(*rA);
    signed64 divisor = (signed32)(*rB);
    if (divisor == 0 /* nb 0x8000..0 is sign extended */
        || (dividend == 0x80000000 && divisor == -1)) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      signed64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19159 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19174 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_OE0_Rc1(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 19203 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2746 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word\n"));
#line 19209 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2746 "../.././sim/ppc/ppc-instructions"
  {
    signed64 dividend = (signed32)(*rA);
    signed64 divisor = (signed32)(*rB);
    if (divisor == 0 /* nb 0x8000..0 is sign extended */
        || (dividend == 0x80000000 && divisor == -1)) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      signed64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19235 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19250 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_to_Condition_Register_from_XER(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Condition_Register_from_XER
#undef MY_PREFIX
#define MY_PREFIX Move_to_Condition_Register_from_XER

  /* extraction: 0.31,6.BF,9./,11./,16./,21.512,31./ #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#line 19269 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3438 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move to Condition Register from XER\n"));
#line 19275 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_to_Condition_Register_from_XER, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3438 "../.././sim/ppc/ppc-instructions"
  error("%s:%d:0x%08lx:%s unimplemented\n",
        itable[MY_INDEX].file, itable[MY_INDEX].line_nr, (long)cia, itable[MY_INDEX].name);
#line 19287 "semantics.c"
  return nia;
  /* extraction: 0.31,6.BF,9./,11./,16./,21.512,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#line 19292 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Carrying_OE1_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Carrying_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 19321 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2597 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Carrying\n"));
#line 19327 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2597 "../.././sim/ppc/ppc-instructions"
  {
    /* RT <- ~RA + RB + 1 === RT <- RB - RA */
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19346 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19361 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Carrying_OE1_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Carrying_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 19390 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2597 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Carrying\n"));
#line 19396 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2597 "../.././sim/ppc/ppc-instructions"
  {
    /* RT <- ~RA + RB + 1 === RT <- RB - RA */
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19415 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19430 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Carrying_OE1_Rc0(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Carrying_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 19459 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2587 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Carrying\n"));
#line 19465 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2587 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19481 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19496 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Carrying_OE1_Rc1(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Carrying_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 19525 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2587 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Carrying\n"));
#line 19531 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2587 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19547 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19562 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_String_Word_Indexed(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_String_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_String_Word_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.533,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 19589 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2329 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load String Word Indexed\n"));
#line 19595 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_String_Word_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2329 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    unsigned_word b;
    int n;
    int r;
    int i;
    int nr;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    n = EXTRACTED32(XER, 25, 31);
    r = RT - 1;
    i = 32;
    nr = (n + 3) / 4;
    if (((RT + nr >= 32)
         ? ((RA >= RT || RA < (RT + nr) % 32)
            || (RB >= RT || RB < (RT + nr) % 32))
         : ((RA >= RT && RA < RT + nr)
            || (RB >= RT && RB < RT + nr)))
        || (RT == RA || RT == RB))
      program_interrupt(processor, cia,
                      illegal_instruction_program_interrupt);
    if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT)
      alignment_interrupt(processor, cia, EA);
    while (n > 0) {
      if (i == 32) {
        r = (r + 1) % 32;
        GPR(r) = 0;
      }
      GPR(r) |= INSERTED(MEM(unsigned, EA, 1), i, i+7);
      i = i + 8;
      if (i == 64) i = 32;
      EA = EA + 1;
      n = n - 1;
    }
  }
#line 19641 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.533,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 19654 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Word_ByteReverse_Indexed(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_ByteReverse_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Word_ByteReverse_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.534,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 19681 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2216 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Word Byte-Reverse Indexed\n"));
#line 19687 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Word_ByteReverse_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2216 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *rT = SWAP_4(MEM(unsigned, EA, 4));
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 19706 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.534,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 19719 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Single_Indexed(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Single_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Single_Indexed

  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.535,31./ #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 19745 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3471 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Single Indexed\n"));
#line 19751 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Single_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3471 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *frT = DOUBLE(MEM(unsigned, EA, 4));
    PPC_INSN_INT_FLOAT(0, FRT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 19770 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.535,31./ #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 19782 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Right_Word_Rc0(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Word_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 19810 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3272 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Right Word\n"));
#line 19816 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Right_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3272 "../.././sim/ppc/ppc-instructions"
  {
    int n = MASKED(*rB, 58, 63);
    unsigned32 source = *rS;
    signed_word shifted;
    if (n < 32)
      shifted = (source >> n);
    else
      shifted = 0;
    *rA = shifted;
    CR0_COMPARE(shifted, 0, Rc);
    ITRACE(trace_alu, \
           ("n=%d, source=0x%lx, shifted=0x%lx\n",
            n, (unsigned long)source, (unsigned long)shifted));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 19841 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 19855 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Right_Word_Rc1(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Word_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 19883 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3272 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Right Word\n"));
#line 19889 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Right_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3272 "../.././sim/ppc/ppc-instructions"
  {
    int n = MASKED(*rB, 58, 63);
    unsigned32 source = *rS;
    signed_word shifted;
    if (n < 32)
      shifted = (source >> n);
    else
      shifted = 0;
    *rA = shifted;
    CR0_COMPARE(shifted, 0, Rc);
    ITRACE(trace_alu, \
           ("n=%d, source=0x%lx, shifted=0x%lx\n",
            n, (unsigned long)source, (unsigned long)shifted));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 19914 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 19928 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_OE1_Rc0(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 19957 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2543 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From\n"));
#line 19963 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2543 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19981 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19996 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_OE1_Rc1(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 20025 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2543 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From\n"));
#line 20031 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2543 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 20049 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 20064 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_TLB_Synchronize(cpu *processor,
                         idecode_cache *cache_entry,
                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_TLB_Synchronize
#undef MY_PREFIX
#define MY_PREFIX TLB_Synchronize

  /* extraction: 0.31,6./,11./,16./,21.566,31./ #define get-values-from-icache */
#line 20081 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4988 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics TLB Synchronize\n"));
#line 20087 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_TLB_Synchronize, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4988 "../.././sim/ppc/ppc-instructions"
  {
    /* nothing happens here - always in sync */
  }
#line 20100 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11./,16./,21.566,31./ #undef get-values-from-icache */
#line 20103 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Single_with_Update_Indexed(cpu *processor,
                                                       idecode_cache *cache_entry,
                                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Single_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Single_with_Update_Indexed

  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.567,31./ #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 20129 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3498 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Single with Update Indexed\n"));
#line 20135 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Single_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3498 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    *frT = DOUBLE(MEM(unsigned, EA, 4));
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, FRT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 20155 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.567,31./ #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 20167 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_Segment_Register(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Segment_Register
#undef MY_PREFIX
#define MY_PREFIX Move_From_Segment_Register

  /* extraction: 0.31,6.RT,11./,12.SR,16./,21.595,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define SR cache_entry->crack.X.SR /* default in icache - extraction */
#line 20188 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4931 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From Segment Register\n"));
#line 20194 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_Segment_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4931 "../.././sim/ppc/ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else
      *rT = SEGREG(SR);
  }
#line 20211 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11./,12.SR,16./,21.595,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef SR
#line 20218 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_String_Word_Immediate(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_String_Word_Immediate
#undef MY_PREFIX
#define MY_PREFIX Load_String_Word_Immediate

  /* extraction: 0.31,6.RT,11.RA,16.NB,21.597,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define NB cache_entry->crack.X.NB /* default in icache - extraction */
#line 20243 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2297 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load String Word Immediate\n"));
#line 20249 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_String_Word_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2297 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    int n;
    int r;
    int i;
    int nr;
    if (RA_is_0) EA = 0;
    else         EA = *rA;
    if (NB == 0) n = 32;
    else         n = NB;
    r = RT - 1;
    i = 32;
    nr = (n + 3) / 4;
    if ((RT + nr >= 32)
        ? (RA >= RT || RA < (RT + nr) % 32)
        : (RA >= RT && RA < RT + nr))
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT)
      alignment_interrupt(processor, cia, EA);
    while (n > 0) {
      if (i == 32) {
        r = (r + 1) % 32;
        GPR(r) = 0;
      }
      GPR(r) |= INSERTED(MEM(unsigned, EA, 1), i, i+7);
      i = i + 8;
      if (i == 64) i = 32;
      EA = EA + 1;
      n = n - 1;
    }
  }
#line 20291 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.NB,21.597,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef NB
#line 20302 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Synchronize(cpu *processor,
                     idecode_cache *cache_entry,
                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Synchronize
#undef MY_PREFIX
#define MY_PREFIX Synchronize

  /* extraction: 0.31,6./,11./,16./,21.598,31./ #define get-values-from-icache */
#line 20319 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2501 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Synchronize\n"));
#line 20325 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Synchronize, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2501 "../.././sim/ppc/ppc-instructions"
  {
    /* do nothing */
  }
#line 20338 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11./,16./,21.598,31./ #undef get-values-from-icache */
#line 20341 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Double_Indexed(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Double_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Double_Indexed

  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.599,31./ #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 20367 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3525 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Double Indexed\n"));
#line 20373 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Double_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3525 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *frT = MEM(unsigned, EA, 8);
    PPC_INSN_INT_FLOAT(0, FRT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 20392 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.599,31./ #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 20404 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Negate_OE1_Rc0(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Negate
#undef MY_PREFIX
#define MY_PREFIX Negate_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 20430 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2677 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Negate\n"));
#line 20436 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Negate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2677 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(1);
    ALU_END(*rT,0/*CA*/,OE,Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 20453 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 20465 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Negate_OE1_Rc1(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Negate
#undef MY_PREFIX
#define MY_PREFIX Negate_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 20491 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2677 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Negate\n"));
#line 20497 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Negate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2677 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(1);
    ALU_END(*rT,0/*CA*/,OE,Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 20514 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 20526 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Double_with_Update_Indexed(cpu *processor,
                                                       idecode_cache *cache_entry,
                                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Double_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Double_with_Update_Indexed

  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.631,31./ #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 20552 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3552 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Double with Update Indexed\n"));
#line 20558 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Double_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3552 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    *frT = MEM(unsigned, EA, 8);
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, FRT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 20578 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.631,31./ #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 20590 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Extended_OE1_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Extended_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 20619 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2621 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Extended\n"));
#line 20625 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2621 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 20643 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 20658 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Extended_OE1_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Extended_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 20687 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2621 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Extended\n"));
#line 20693 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2621 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 20711 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 20726 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Extended_OE1_Rc0(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_Extended_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 20755 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2610 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Extended\n"));
#line 20761 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2610 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 20778 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 20793 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Extended_OE1_Rc1(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_Extended_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 20822 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2610 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Extended\n"));
#line 20828 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2610 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 20845 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 20860 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_Segment_Register_Indirect(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Segment_Register_Indirect
#undef MY_PREFIX
#define MY_PREFIX Move_From_Segment_Register_Indirect

  /* extraction: 0.31,6.RT,11./,16.RB,21.659,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 20883 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4942 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From Segment Register Indirect\n"));
#line 20889 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_Segment_Register_Indirect, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4942 "../.././sim/ppc/ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else
      *rT = SEGREG(EXTRACTED32(*rB, 0, 3));
  }
#line 20906 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11./,16.RB,21.659,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RB
#undef rB
#undef RB_BITMASK
#line 20915 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_String_Word_Indexed(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_String_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_String_Word_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.661,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 20942 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2387 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store String Word Indexed\n"));
#line 20948 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_String_Word_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2387 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    unsigned_word b;
    int n;
    int r;
    int i;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT)
      alignment_interrupt(processor, cia, EA);
    n = EXTRACTED32(XER, 25, 31);
    r = RS - 1;
    i = 32;
    while (n > 0) {
      if (i == 32) r = (r + 1) % 32;
      STORE(EA, 1, EXTRACTED(GPR(r), i, i+7));
      i = i + 8;
      if (i == 64) i = 32;
      EA = EA + 1;
      n = n - 1;
    }
  }
#line 20981 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.661,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 20994 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Word_ByteReversed_Indexed(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_ByteReversed_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Word_ByteReversed_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.662,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 21021 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2242 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Word Byte-Reversed Indexed\n"));
#line 21027 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Word_ByteReversed_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2242 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 4, SWAP_4(*rS));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
  }
#line 21046 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.662,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 21059 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Single_Indexed(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Single_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Single_Indexed

  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.663,31./ #define get-values-from-icache */
#define frS cache_entry->crack.X.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.X.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 21085 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3584 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Single Indexed\n"));
#line 21091 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Single_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3584 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 4, SINGLE(*frS));
    PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
  }
#line 21110 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.663,31./ #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 21122 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Single_with_Update_Indexed(cpu *processor,
                                                        idecode_cache *cache_entry,
                                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Single_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Single_with_Update_Indexed

  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.695,31./ #define get-values-from-icache */
#define frS cache_entry->crack.X.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.X.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 21148 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3611 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Single with Update Indexed\n"));
#line 21154 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Single_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3611 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    STORE(EA, 4, SINGLE(*frS));
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
  }
#line 21174 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.695,31./ #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 21186 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_from_Zero_Extended_OE1_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_from_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_from_Zero_Extended_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 21212 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2666 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract from Zero Extended\n"));
#line 21218 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_from_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2666 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21235 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21247 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_from_Zero_Extended_OE1_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_from_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_from_Zero_Extended_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 21273 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2666 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract from Zero Extended\n"));
#line 21279 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_from_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2666 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21296 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21308 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Zero_Extended_OE1_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Zero_Extended_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 21334 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2656 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Zero Extended\n"));
#line 21340 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2656 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21356 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21368 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Zero_Extended_OE1_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Zero_Extended_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 21394 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2656 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Zero Extended\n"));
#line 21400 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2656 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21416 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21428 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_String_Word_Immedate(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_String_Word_Immedate
#undef MY_PREFIX
#define MY_PREFIX Store_String_Word_Immedate

  /* extraction: 0.31,6.RS,11.RA,16.NB,21.725,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define NB cache_entry->crack.X.NB /* default in icache - extraction */
#line 21453 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2365 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store String Word Immedate\n"));
#line 21459 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_String_Word_Immedate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2365 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    int n;
    int r;
    int i;
    if (RA_is_0) EA = 0;
    else         EA = *rA;
    if (NB == 0) n = 32;
    else         n = NB;
    r = RS - 1;
    i = 32;
    if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT)
      alignment_interrupt(processor, cia, EA);
    while (n > 0) {
      if (i == 32) r = (r + 1) % 32;
      STORE(EA, 1, EXTRACTED(GPR(r), i, i+7));
      i = i + 8;
      if (i == 64) i = 32;
      EA = EA + 1;
      n = n - 1;
    }
  }
#line 21491 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.NB,21.725,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef NB
#line 21502 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Double_Indexed(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Double_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Double_Indexed

  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.727,31./ #define get-values-from-icache */
#define frS cache_entry->crack.X.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.X.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 21528 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3638 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Double Indexed\n"));
#line 21534 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Double_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3638 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 8, *frS);
    PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
  }
#line 21553 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.727,31./ #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 21565 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Minus_One_Extended_OE1_Rc0(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Minus_One_Extended_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 21591 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2644 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Minus One Extended\n"));
#line 21597 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2644 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21615 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21627 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Minus_One_Extended_OE1_Rc1(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Minus_One_Extended_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 21653 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2644 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Minus One Extended\n"));
#line 21659 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2644 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21677 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21689 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Minus_One_Extended_OE1_Rc0(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Minus_One_Extended_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 21715 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2633 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Minus One Extended\n"));
#line 21721 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2633 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21738 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21750 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Minus_One_Extended_OE1_Rc1(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Minus_One_Extended_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 21776 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2633 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Minus One Extended\n"));
#line 21782 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2633 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21799 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21811 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_Low_Word_OE1_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Word_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 21840 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2699 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply Low Word\n"));
#line 21846 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_Low_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2699 "../.././sim/ppc/ppc-instructions"
  {
    signed64 a = (signed32)(*rA);
    signed64 b = (signed32)(*rB);
    signed64 prod = a * b;
    signed_word t = prod;
    *rT = *rA * *rB;
    if (t != prod && OE)
      XER |= (xer_overflow | xer_summary_overflow);
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 21867 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 21882 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_Low_Word_OE1_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Word_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 21911 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2699 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply Low Word\n"));
#line 21917 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_Low_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2699 "../.././sim/ppc/ppc-instructions"
  {
    signed64 a = (signed32)(*rA);
    signed64 b = (signed32)(*rB);
    signed64 prod = a * b;
    signed_word t = prod;
    *rT = *rA * *rB;
    if (t != prod && OE)
      XER |= (xer_overflow | xer_summary_overflow);
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 21938 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 21953 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Double_with_Update_Indexed(cpu *processor,
                                                        idecode_cache *cache_entry,
                                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Double_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Double_with_Update_Indexed

  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.759,31./ #define get-values-from-icache */
#define frS cache_entry->crack.X.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.X.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 21979 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3677 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Double with Update Indexed\n"));
#line 21985 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Double_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3677 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    STORE(EA, 8, *frS);
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
  }
#line 22005 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.759,31./ #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 22017 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_OE1_Rc0(cpu *processor,
                     idecode_cache *cache_entry,
                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add
#undef MY_PREFIX
#define MY_PREFIX Add_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 22046 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2533 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add\n"));
#line 22052 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2533 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 22068 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 22083 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_OE1_Rc1(cpu *processor,
                     idecode_cache *cache_entry,
                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add
#undef MY_PREFIX
#define MY_PREFIX Add_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 22112 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2533 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add\n"));
#line 22118 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2533 "../.././sim/ppc/ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 22134 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 22149 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_ByteReverse_Indexed(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_ByteReverse_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_ByteReverse_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.790,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 22176 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2203 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword Byte-Reverse Indexed\n"));
#line 22182 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_ByteReverse_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2203 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *rT = SWAP_2(MEM(unsigned, EA, 2));
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 22201 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.790,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 22214 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Right_Algebraic_Word_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Algebraic_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Algebraic_Word_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 22242 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3315 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Right Algebraic Word\n"));
#line 22248 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Right_Algebraic_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3315 "../.././sim/ppc/ppc-instructions"
  {
    unsigned64 mask;
    int n = MASKED(*rB, 59, 63);
    signed32 source = (signed32)*rS; /* signed to keep sign bit */
    signed32 shifted = source >> n;
    int S = (MASKED(*rS,32,32) != 0);
    signed64 r = ((unsigned64) source);
    r = ((unsigned64) source) << 32 | (unsigned32) source;
    r = ROTL64(r,64-n);
    if (MASKED(*rB,58,58) == 0)
    	mask = (unsigned64) MASK64(n+32,63);
    else
    	mask = (unsigned64) 0;
    *rA = (signed_word) (r & mask | ((signed64) -1*S) & ~mask); /* if 64bit will sign extend */
    if (S && (MASKED(r & ~mask,32,63)!=0))
      XER |= xer_carry;
    else
      XER &= ~xer_carry;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx), XER = %ld\n",
    		   (long)*rA, (long)*rA, (long)XER));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22281 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 22295 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Right_Algebraic_Word_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Algebraic_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Algebraic_Word_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 22323 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3315 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Right Algebraic Word\n"));
#line 22329 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Right_Algebraic_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3315 "../.././sim/ppc/ppc-instructions"
  {
    unsigned64 mask;
    int n = MASKED(*rB, 59, 63);
    signed32 source = (signed32)*rS; /* signed to keep sign bit */
    signed32 shifted = source >> n;
    int S = (MASKED(*rS,32,32) != 0);
    signed64 r = ((unsigned64) source);
    r = ((unsigned64) source) << 32 | (unsigned32) source;
    r = ROTL64(r,64-n);
    if (MASKED(*rB,58,58) == 0)
    	mask = (unsigned64) MASK64(n+32,63);
    else
    	mask = (unsigned64) 0;
    *rA = (signed_word) (r & mask | ((signed64) -1*S) & ~mask); /* if 64bit will sign extend */
    if (S && (MASKED(r & ~mask,32,63)!=0))
      XER |= xer_carry;
    else
      XER &= ~xer_carry;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx), XER = %ld\n",
    		   (long)*rA, (long)*rA, (long)XER));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22362 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 22376 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Right_Algebraic_Word_Immediate_Rc0(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Algebraic_Word_Immediate
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Algebraic_Word_Immediate_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define SH cache_entry->crack.X.SH /* default in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 22402 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3293 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Right Algebraic Word Immediate\n"));
#line 22408 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Right_Algebraic_Word_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3293 "../.././sim/ppc/ppc-instructions"
  {
    int n = SH;
    signed_word r = ROTL32(*rS, /*64*/32-n);
    signed_word m = MASK(n+32, 63);
    int S = MASKED(*rS, 32, 32);
    signed_word shifted = (r & m) | (S ? ~m : 0);
    *rA = shifted;
    if (S && ((r & ~m) & MASK(32, 63)) != 0)
      XER |= xer_carry;
    else
      XER &= ~xer_carry;
    CR0_COMPARE(shifted, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx), XER = %ld\n",
    		   (long)*rA, (long)*rA, (long)XER));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22434 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef SH
#undef Rc
#line 22446 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Right_Algebraic_Word_Immediate_Rc1(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Algebraic_Word_Immediate
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Algebraic_Word_Immediate_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define SH cache_entry->crack.X.SH /* default in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 22472 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3293 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Right Algebraic Word Immediate\n"));
#line 22478 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Right_Algebraic_Word_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3293 "../.././sim/ppc/ppc-instructions"
  {
    int n = SH;
    signed_word r = ROTL32(*rS, /*64*/32-n);
    signed_word m = MASK(n+32, 63);
    int S = MASKED(*rS, 32, 32);
    signed_word shifted = (r & m) | (S ? ~m : 0);
    *rA = shifted;
    if (S && ((r & ~m) & MASK(32, 63)) != 0)
      XER |= xer_carry;
    else
      XER &= ~xer_carry;
    CR0_COMPARE(shifted, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx), XER = %ld\n",
    		   (long)*rA, (long)*rA, (long)XER));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22504 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef SH
#undef Rc
#line 22516 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Enforce_Inorder_Execution_of_IO(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Enforce_Inorder_Execution_of_IO
#undef MY_PREFIX
#define MY_PREFIX Enforce_Inorder_Execution_of_IO

  /* extraction: 0.31,6./,11./,16./,21.854,31./ #define get-values-from-icache */
#line 22533 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4805 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Enforce In-order Execution of I/O\n"));
#line 22539 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Enforce_Inorder_Execution_of_IO, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4805 "../.././sim/ppc/ppc-instructions"
  {
    /* Since this model has no instruction overlap
       this instruction need do nothing */
  }
#line 22553 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11./,16./,21.854,31./ #undef get-values-from-icache */
#line 22556 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Half_Word_ByteReversed_Indexed(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word_ByteReversed_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word_ByteReversed_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.918,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 22583 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Half Word Byte-Reversed Indexed\n"));
#line 22589 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Half_Word_ByteReversed_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2229 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 2, SWAP_2(*rS));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
  }
#line 22608 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.918,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 22621 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Extend_Sign_Half_Word_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Extend_Sign_Half_Word
#undef MY_PREFIX
#define MY_PREFIX Extend_Sign_Half_Word_Rc0

  /* extraction: 0.31,6.RS,11.RA,16./,21.922,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define Rc 0 /* default in icache - constant field */
#line 22646 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3101 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Extend Sign Half Word\n"));
#line 22652 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Extend_Sign_Half_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3101 "../.././sim/ppc/ppc-instructions"
  {
    *rA = (signed_word)(signed16)*rS;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22668 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16./,21.922,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef Rc
#line 22679 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Extend_Sign_Half_Word_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Extend_Sign_Half_Word
#undef MY_PREFIX
#define MY_PREFIX Extend_Sign_Half_Word_Rc1

  /* extraction: 0.31,6.RS,11.RA,16./,21.922,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define Rc 1 /* default in icache - constant field */
#line 22704 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3101 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Extend Sign Half Word\n"));
#line 22710 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Extend_Sign_Half_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3101 "../.././sim/ppc/ppc-instructions"
  {
    *rA = (signed_word)(signed16)*rS;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22726 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16./,21.922,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef Rc
#line 22737 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Extend_Sign_Byte_Rc0(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Extend_Sign_Byte
#undef MY_PREFIX
#define MY_PREFIX Extend_Sign_Byte_Rc0

  /* extraction: 0.31,6.RS,11.RA,16./,21.954,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define Rc 0 /* default in icache - constant field */
#line 22762 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3091 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Extend Sign Byte\n"));
#line 22768 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Extend_Sign_Byte, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3091 "../.././sim/ppc/ppc-instructions"
  {
    *rA = (signed_word)(signed8)*rS;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22784 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16./,21.954,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef Rc
#line 22795 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Extend_Sign_Byte_Rc1(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Extend_Sign_Byte
#undef MY_PREFIX
#define MY_PREFIX Extend_Sign_Byte_Rc1

  /* extraction: 0.31,6.RS,11.RA,16./,21.954,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define Rc 1 /* default in icache - constant field */
#line 22820 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3091 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Extend Sign Byte\n"));
#line 22826 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Extend_Sign_Byte, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3091 "../.././sim/ppc/ppc-instructions"
  {
    *rA = (signed_word)(signed8)*rS;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22842 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16./,21.954,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef Rc
#line 22853 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_Unsigned_OE1_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_Unsigned_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 22882 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2768 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word Unsigned\n"));
#line 22888 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word_Unsigned, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2768 "../.././sim/ppc/ppc-instructions"
  {
    unsigned64 dividend = (unsigned32)(*rA);
    unsigned64 divisor = (unsigned32)(*rB);
    if (divisor == 0) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      unsigned64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 22913 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 22928 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_Unsigned_OE1_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_Unsigned_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 22957 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2768 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word Unsigned\n"));
#line 22963 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word_Unsigned, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2768 "../.././sim/ppc/ppc-instructions"
  {
    unsigned64 dividend = (unsigned32)(*rA);
    unsigned64 divisor = (unsigned32)(*rB);
    if (divisor == 0) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      unsigned64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 22988 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 23003 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Instruction_Cache_Block_Invalidate(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Instruction_Cache_Block_Invalidate
#undef MY_PREFIX
#define MY_PREFIX Instruction_Cache_Block_Invalidate

  /* extraction: 0.31,6./,11.RA,16.RB,21.982,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 23027 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4741 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Instruction Cache Block Invalidate\n"));
#line 23033 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Instruction_Cache_Block_Invalidate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4741 "../.././sim/ppc/ppc-instructions"
  {
    /* blindly flush all instruction cache entries */
#if WITH_IDECODE_CACHE_SIZE
    cpu_flush_icache(processor);
#endif
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 23050 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.982,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 23060 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Integer_Word_Indexed(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Integer_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Integer_Word_Indexed

  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.983,31./ #define get-values-from-icache */
#define frS cache_entry->crack.X.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.X.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 23086 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3650 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Integer Word Indexed\n"));
#line 23092 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Integer_Word_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3650 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 4, *frS);
    PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
  }
#line 23111 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.983,31./ #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 23123 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_OE1_Rc0(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 23152 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2746 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word\n"));
#line 23158 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2746 "../.././sim/ppc/ppc-instructions"
  {
    signed64 dividend = (signed32)(*rA);
    signed64 divisor = (signed32)(*rB);
    if (divisor == 0 /* nb 0x8000..0 is sign extended */
        || (dividend == 0x80000000 && divisor == -1)) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      signed64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 23184 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 23199 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_OE1_Rc1(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 23228 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2746 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word\n"));
#line 23234 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2746 "../.././sim/ppc/ppc-instructions"
  {
    signed64 dividend = (signed32)(*rA);
    signed64 divisor = (signed32)(*rB);
    if (divisor == 0 /* nb 0x8000..0 is sign extended */
        || (dividend == 0x80000000 && divisor == -1)) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      signed64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 23260 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 23275 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Data_Cache_Block_set_to_Zero(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_set_to_Zero
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_set_to_Zero

  /* extraction: 0.31,6./,11.RA,16.RB,21.1014,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 23299 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4781 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Data Cache Block set to Zero\n"));
#line 23305 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Data_Cache_Block_set_to_Zero, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4781 "../.././sim/ppc/ppc-instructions"
  {
    TRACE(trace_tbd,("Data Cache Block set to Zero\n"));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
  }
#line 23319 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.1014,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 23329 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Word_and_Zero(cpu *processor,
                            idecode_cache *cache_entry,
                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_and_Zero
#undef MY_PREFIX
#define MY_PREFIX Load_Word_and_Zero

  /* extraction: 0.32,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23354 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1886 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Word and Zero\n"));
#line 23360 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Word_and_Zero, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1886 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    *rT = MEM(unsigned, EA, 4);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 23379 "semantics.c"
  return nia;
  /* extraction: 0.32,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23390 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Word_and_Zero_with_Update(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_and_Zero_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_Word_and_Zero_with_Update

  /* extraction: 0.33,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23415 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1912 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Word and Zero with Update\n"));
#line 23421 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Word_and_Zero_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1912 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    *rT = MEM(unsigned, EA, 4);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK, 0);
  }
#line 23441 "semantics.c"
  return nia;
  /* extraction: 0.33,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23452 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Byte_and_Zero(cpu *processor,
                            idecode_cache *cache_entry,
                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Byte_and_Zero
#undef MY_PREFIX
#define MY_PREFIX Load_Byte_and_Zero

  /* extraction: 0.34,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23477 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1723 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Byte and Zero\n"));
#line 23483 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Byte_and_Zero, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1723 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    *rT = MEM(unsigned, EA, 1);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 23502 "semantics.c"
  return nia;
  /* extraction: 0.34,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23513 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Byte_and_Zero_with_Update(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Byte_and_Zero_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_Byte_and_Zero_with_Update

  /* extraction: 0.35,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23538 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1750 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Byte and Zero with Update\n"));
#line 23544 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Byte_and_Zero_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1750 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    *rT = MEM(unsigned, EA, 1);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK, 0);
  }
#line 23564 "semantics.c"
  return nia;
  /* extraction: 0.35,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23575 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Word(cpu *processor,
                    idecode_cache *cache_entry,
                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word
#undef MY_PREFIX
#define MY_PREFIX Store_Word

  /* extraction: 0.36,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23600 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2113 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Word\n"));
#line 23606 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2113 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    STORE(EA, 4, *rS);
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RS_BITMASK, 0);
  }
#line 23625 "semantics.c"
  return nia;
  /* extraction: 0.36,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23636 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Word_with_Update(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_Word_with_Update

  /* extraction: 0.37,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23661 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Word with Update\n"));
#line 23667 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Word_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2139 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    STORE(EA, 4, *rS);
    *rA = EA;
    PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RS_BITMASK, 0);
  }
#line 23687 "semantics.c"
  return nia;
  /* extraction: 0.37,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23698 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Byte(cpu *processor,
                    idecode_cache *cache_entry,
                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Byte
#undef MY_PREFIX
#define MY_PREFIX Store_Byte

  /* extraction: 0.38,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23723 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2005 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Byte\n"));
#line 23729 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Byte, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2005 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    STORE(EA, 1, *rS);
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RS_BITMASK, 0);
  }
#line 23748 "semantics.c"
  return nia;
  /* extraction: 0.38,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23759 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Byte_with_Update(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Byte_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_Byte_with_Update

  /* extraction: 0.39,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23784 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2031 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Byte with Update\n"));
#line 23790 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Byte_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2031 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    STORE(EA, 1, *rS);
    *rA = EA;
    PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RS_BITMASK, 0);
  }
#line 23810 "semantics.c"
  return nia;
  /* extraction: 0.39,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23821 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_and_Zero(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_and_Zero
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_and_Zero

  /* extraction: 0.40,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23846 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1778 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword and Zero\n"));
#line 23852 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_and_Zero, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1778 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    *rT = MEM(unsigned, EA, 2);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 23871 "semantics.c"
  return nia;
  /* extraction: 0.40,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23882 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_and_Zero_with_Update(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_and_Zero_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_and_Zero_with_Update

  /* extraction: 0.41,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23907 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1804 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword and Zero with Update\n"));
#line 23913 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_and_Zero_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1804 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    *rT = MEM(unsigned, EA, 2);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK, 0);
  }
#line 23933 "semantics.c"
  return nia;
  /* extraction: 0.41,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23944 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_Algebraic(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_Algebraic
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_Algebraic

  /* extraction: 0.42,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23969 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1832 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword Algebraic\n"));
#line 23975 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_Algebraic, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1832 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    *rT = MEM(signed, EA, 2);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 23994 "semantics.c"
  return nia;
  /* extraction: 0.42,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24005 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_Algebraic_with_Update(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_Algebraic_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_Algebraic_with_Update

  /* extraction: 0.43,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24030 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1858 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword Algebraic with Update\n"));
#line 24036 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_Algebraic_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1858 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    *rT = MEM(signed, EA, 2);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK, 0);
  }
#line 24056 "semantics.c"
  return nia;
  /* extraction: 0.43,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24067 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Half_Word(cpu *processor,
                         idecode_cache *cache_entry,
                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word

  /* extraction: 0.44,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24092 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2059 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Half Word\n"));
#line 24098 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Half_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2059 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    STORE(EA, 2, *rS);
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RS_BITMASK, 0);
  }
#line 24117 "semantics.c"
  return nia;
  /* extraction: 0.44,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24128 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Half_Word_with_Update(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word_with_Update

  /* extraction: 0.45,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24153 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2085 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Half Word with Update\n"));
#line 24159 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Half_Word_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2085 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    STORE(EA, 2, *rS);
    *rA = EA;
    PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RS_BITMASK, 0);
  }
#line 24179 "semantics.c"
  return nia;
  /* extraction: 0.45,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24190 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Multiple_Word(cpu *processor,
                            idecode_cache *cache_entry,
                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Multiple_Word
#undef MY_PREFIX
#define MY_PREFIX Load_Multiple_Word

  /* extraction: 0.46,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24215 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2256 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Multiple Word\n"));
#line 24221 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Multiple_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2256 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    unsigned_word b;
    int r;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    r = RT;
    if (RA >= r)
      program_interrupt(processor, cia,
                      illegal_instruction_program_interrupt);
    if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT || (EA % 4 != 0))
      alignment_interrupt(processor, cia, EA);
    while (r <= 31) {
      GPR(r) = MEM(unsigned, EA, 4);
      r = r + 1;
      EA = EA + 4;
    }
  }
#line 24250 "semantics.c"
  return nia;
  /* extraction: 0.46,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24261 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Multiple_Word(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Multiple_Word
#undef MY_PREFIX
#define MY_PREFIX Store_Multiple_Word

  /* extraction: 0.47,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24286 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2275 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Multiple Word\n"));
#line 24292 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Multiple_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2275 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    unsigned_word b;
    int r;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT
        || (EA % 4 != 0))
      alignment_interrupt(processor, cia, EA);
    r = RS;
    while (r <= 31) {
      STORE(EA, 4, GPR(r));
      r = r + 1;
      EA = EA + 4;
    }
  }
#line 24319 "semantics.c"
  return nia;
  /* extraction: 0.47,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24330 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Single(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Single
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Single

  /* extraction: 0.48,6.FRT,11.RA,16.D #define get-values-from-icache */
#define frT cache_entry->crack.D.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.D.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24354 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3458 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Single\n"));
#line 24360 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3458 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    *frT = DOUBLE(MEM(unsigned, EA, 4));
    PPC_INSN_INT_FLOAT(0, FRT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 24379 "semantics.c"
  return nia;
  /* extraction: 0.48,6.FRT,11.RA,16.D #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24389 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Single_with_Update(cpu *processor,
                                               idecode_cache *cache_entry,
                                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Single_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Single_with_Update

  /* extraction: 0.49,6.FRT,11.RA,16.D #define get-values-from-icache */
#define frT cache_entry->crack.D.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.D.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24413 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3484 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Single with Update\n"));
#line 24419 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Single_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3484 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    *frT = DOUBLE(MEM(unsigned, EA, 4));
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, FRT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 24439 "semantics.c"
  return nia;
  /* extraction: 0.49,6.FRT,11.RA,16.D #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24449 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Double(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Double
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Double

  /* extraction: 0.50,6.FRT,11.RA,16.D #define get-values-from-icache */
#define frT cache_entry->crack.D.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.D.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24473 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3512 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Double\n"));
#line 24479 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Double, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3512 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    *frT = MEM(unsigned, EA, 8);
    PPC_INSN_INT_FLOAT(0, FRT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 24498 "semantics.c"
  return nia;
  /* extraction: 0.50,6.FRT,11.RA,16.D #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24508 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Double_with_Update(cpu *processor,
                                               idecode_cache *cache_entry,
                                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Double_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Double_with_Update

  /* extraction: 0.51,6.FRT,11.RA,16.D #define get-values-from-icache */
#define frT cache_entry->crack.D.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.D.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24532 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3538 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Double with Update\n"));
#line 24538 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Double_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3538 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    *frT = MEM(unsigned, EA, 8);
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, FRT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 24558 "semantics.c"
  return nia;
  /* extraction: 0.51,6.FRT,11.RA,16.D #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24568 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Single(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Single
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Single

  /* extraction: 0.52,6.FRS,11.RA,16.D #define get-values-from-icache */
#define frS cache_entry->crack.D.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.D.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24592 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3571 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Single\n"));
#line 24598 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3571 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    STORE(EA, 4, SINGLE(*frS));
    PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1), FRS_BITMASK);
  }
#line 24617 "semantics.c"
  return nia;
  /* extraction: 0.52,6.FRS,11.RA,16.D #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24627 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Single_with_Update(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Single_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Single_with_Update

  /* extraction: 0.53,6.FRS,11.RA,16.D #define get-values-from-icache */
#define frS cache_entry->crack.D.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.D.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24651 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3597 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Single with Update\n"));
#line 24657 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Single_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3597 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    STORE(EA, 4, SINGLE(*frS));
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, 0, (RA_BITMASK & ~1), FRS_BITMASK);
  }
#line 24677 "semantics.c"
  return nia;
  /* extraction: 0.53,6.FRS,11.RA,16.D #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24687 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Double(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Double
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Double

  /* extraction: 0.54,6.FRS,11.RA,16.D #define get-values-from-icache */
#define frS cache_entry->crack.D.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.D.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24711 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3625 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Double\n"));
#line 24717 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Double, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3625 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    STORE(EA, 8, *frS);
    PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1), FRS_BITMASK);
  }
#line 24736 "semantics.c"
  return nia;
  /* extraction: 0.54,6.FRS,11.RA,16.D #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24746 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Double_with_Update(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Double_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Double_with_Update

  /* extraction: 0.55,6.FRS,11.RA,16.D #define get-values-from-icache */
#define frS cache_entry->crack.D.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.D.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24770 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3663 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Double with Update\n"));
#line 24776 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Double_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3663 "../.././sim/ppc/ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    STORE(EA, 8, *frS);
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, 0, (RA_BITMASK & ~1), FRS_BITMASK);
  }
#line 24796 "semantics.c"
  return nia;
  /* extraction: 0.55,6.FRS,11.RA,16.D #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24806 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Divide_Single_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Divide_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Divide_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 24830 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3926 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Divide Single\n"));
#line 24836 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Divide_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3926 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxzdz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else if (is_invalid_zero_divide (processor, cia,
                                     *frA, *frB,
                                     1 /*single?*/)) {
      invalid_zero_divide_operation (processor, cia,
                                     frT, *frA, *frB,
                                     1 /*single?*/);
    }
    else {
      /*HACK!*/
      float s = *(double*)frA / *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 24875 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 24885 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Divide_Single_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Divide_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Divide_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 24909 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3926 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Divide Single\n"));
#line 24915 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Divide_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3926 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxzdz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else if (is_invalid_zero_divide (processor, cia,
                                     *frA, *frB,
                                     1 /*single?*/)) {
      invalid_zero_divide_operation (processor, cia,
                                     frT, *frA, *frB,
                                     1 /*single?*/);
    }
    else {
      /*HACK!*/
      float s = *(double*)frA / *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 24954 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 24964 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Subtract_Single_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Subtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Subtract_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 24988 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3815 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Subtract Single\n"));
#line 24994 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Subtract_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3815 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             1) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = *(double*)frA - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 25026 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25036 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Subtract_Single_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Subtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Subtract_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25060 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3815 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Subtract Single\n"));
#line 25066 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Subtract_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3815 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             1) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = *(double*)frA - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 25098 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25108 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Add_Single_Rc0(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Add_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Add_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25132 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3763 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Add Single\n"));
#line 25138 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Add_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3763 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = *(double*)frA + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 25170 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25180 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Add_Single_Rc1(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Add_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Add_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25204 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3763 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Add Single\n"));
#line 25210 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Add_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3763 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = *(double*)frA + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 25242 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25252 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Square_Root_Single_Rc0(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Square_Root_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Square_Root_Single_Rc0

  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25274 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4704 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Square Root Single\n"));
#line 25280 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Square_Root_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4704 "../.././sim/ppc/ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 25293 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25301 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Square_Root_Single_Rc1(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Square_Root_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Square_Root_Single_Rc1

  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25323 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4704 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Square Root Single\n"));
#line 25329 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Square_Root_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4704 "../.././sim/ppc/ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 25342 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25350 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Reciprocal_Estimate_Single_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Reciprocal_Estimate_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Reciprocal_Estimate_Single_Rc0

  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25372 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4707 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Reciprocal Estimate Single\n"));
#line 25378 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Reciprocal_Estimate_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4707 "../.././sim/ppc/ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 25391 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25399 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Reciprocal_Estimate_Single_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Reciprocal_Estimate_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Reciprocal_Estimate_Single_Rc1

  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25421 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4707 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Reciprocal Estimate Single\n"));
#line 25427 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Reciprocal_Estimate_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4707 "../.././sim/ppc/ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 25440 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25448 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_Single_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25472 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3867 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply Single\n"));
#line 25478 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3867 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 25510 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 25520 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_Single_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25544 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3867 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply Single\n"));
#line 25550 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3867 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 25582 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 25592 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_Single_Rc0(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25618 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4094 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract Single\n"));
#line 25624 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4094 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = product - *(double*)frB;
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 25675 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 25687 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_Single_Rc1(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25713 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4094 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract Single\n"));
#line 25719 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4094 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = product - *(double*)frB;
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 25770 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 25782 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_Single_Rc0(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25808 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4004 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add Single\n"));
#line 25814 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4004 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = product + *(double*)frB;
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 25865 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 25877 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_Single_Rc1(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25903 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4004 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add Single\n"));
#line 25909 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4004 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = product + *(double*)frB;
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 25960 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 25972 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_Single_Rc0(cpu *processor,
                                                       idecode_cache *cache_entry,
                                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25998 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4274 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract Single\n"));
#line 26004 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4274 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = -(product - *(double*)frB);
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 26055 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 26067 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_Single_Rc1(cpu *processor,
                                                       idecode_cache *cache_entry,
                                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 26093 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4274 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract Single\n"));
#line 26099 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4274 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = -(product - *(double*)frB);
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 26150 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 26162 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_Single_Rc0(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 26188 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4184 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add Single\n"));
#line 26194 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4184 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = -(product + *(double*)frB);
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 26245 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 26257 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_Single_Rc1(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 26283 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4184 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add Single\n"));
#line 26289 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4184 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = -(product + *(double*)frB);
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 26340 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 26352 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Compare_Unordered(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Compare_Unordered
#undef MY_PREFIX
#define MY_PREFIX Floating_Compare_Unordered

  /* extraction: 0.63,6.BF,9./,11.FRA,16.FRB,21.0,31./ #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.X.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.X.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#line 26375 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4599 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Compare Unordered\n"));
#line 26381 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Compare_Unordered, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4599 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned c;
    if (is_NaN(*frA, 0) || is_NaN(*frB, 0))
      c = cr_i_summary_overflow; /* 0b0001 - (FRA) ? (FRB) */
    else if (is_less_than(frA, frB))
      c = cr_i_negative; /* 0b1000 - (FRA) < (FRB) */
    else if (is_greater_than(frA, frB))
      c = cr_i_positive; /* 0b0100 - (FRA) > (FRB) */
    else
      c = cr_i_zero; /* 0b0010 - (FRA) = (FRB) */
    FPSCR_SET_FPCC(c);
    CR_SET(BF, c); /* CR[4*BF..4*BF+3] = c */
    if (is_SNaN(*frA, 0) || is_SNaN(*frB, 0))
      FPSCR_OR_VX(fpscr_vxsnan);
    FPSCR_END(0);
    PPC_INSN_FLOAT_CR(0, FRA_BITMASK | FRB_BITMASK, BF_BITMASK);
  }
#line 26409 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BF,9./,11.FRA,16.FRB,21.0,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#line 26418 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Round_to_SinglePrecision_Rc0(cpu *processor,
                                               idecode_cache *cache_entry,
                                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Round_to_SinglePrecision
#undef MY_PREFIX
#define MY_PREFIX Floating_Round_to_SinglePrecision_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 26440 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4324 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Round to Single-Precision\n"));
#line 26446 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Round_to_SinglePrecision, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4324 "../.././sim/ppc/ppc-instructions"
  {
    int sign;
    int exp;
    unsigned64 frac_grx;
    /***/
      /* split off cases for what to do */
      if (EXTRACTED64(*frB, 1, 11) < 897
          && EXTRACTED64(*frB, 1, 63) > 0) {
          if ((FPSCR & fpscr_ue) == 0) GOTO(Disabled_Exponent_Underflow);
          if ((FPSCR & fpscr_ue) != 0) GOTO(Enabled_Exponent_Underflow);
      }
      if (EXTRACTED64(*frB, 1, 11) > 1150
          && EXTRACTED64(*frB, 1, 11) < 2047) {
          if ((FPSCR & fpscr_oe) == 0) GOTO(Disabled_Exponent_Overflow);
          if ((FPSCR & fpscr_oe) != 0) GOTO(Enabled_Exponent_Overflow);
      }
      if (EXTRACTED64(*frB, 1, 11) > 896
          && EXTRACTED64(*frB, 1, 11) < 1151) GOTO(Normal_Operand);
      if (EXTRACTED64(*frB, 1, 63) == 0) GOTO(Zero_Operand);
      if (EXTRACTED64(*frB, 1, 11) == 2047) {
        if (EXTRACTED64(*frB, 12, 63) == 0) GOTO(Infinity_Operand);
        if (EXTRACTED64(*frB, 12, 12) == 1) GOTO(QNaN_Operand);
        if (EXTRACTED64(*frB, 12, 12) == 0
            && EXTRACTED64(*frB, 13, 63) > 0) GOTO(SNaN_Operand);
      }
    /**/
    LABEL(Disabled_Exponent_Underflow):
      sign = EXTRACTED64(*frB, 0, 0);
      if (EXTRACTED64(*frB, 1, 11) == 0) {
        exp = -1022;
        frac_grx = INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      }
      if (EXTRACTED64(*frB, 1, 11) > 0) {
        exp = EXTRACTED64(*frB, 1, 11) - 1023;
        frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      }
        /* G|R|X == zero from above */
        while (exp < -126) {
          exp = exp + 1;
          frac_grx = (INSERTED64(EXTRACTED64(frac_grx, 0, 54), 1, 55)
                      | MASKED64(frac_grx, 55, 55));
        }
      FPSCR_SET_UX(EXTRACTED64(frac_grx, 24, 55) > 0);
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
      if (EXTRACTED64(frac_grx, 0, 52) == 0) {
        *frT = INSERTED64(sign, 0, 0);
        if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_zero);
        if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_zero);
      }
      if (EXTRACTED64(frac_grx, 0, 52) > 0) {
        if (EXTRACTED64(frac_grx, 0, 0) == 1) {
          if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
          if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        }
        if (EXTRACTED64(frac_grx, 0, 0) == 0) {
          if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_denormalized_number);
          if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_denormalized_number);
        }
        /*Normalize_Operand:*/
          while (EXTRACTED64(frac_grx, 0, 0) == 0) {
            exp = exp - 1;
            frac_grx = INSERTED64(EXTRACTED64(frac_grx, 1,  52), 0, 51);
          }
        *frT = (INSERTED64(sign, 0, 0)
                | INSERTED64(exp + 1023, 1, 11)
                | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      }
      GOTO(Done);
    /**/
    LABEL(Enabled_Exponent_Underflow):
      FPSCR_SET_UX(1);
      sign = EXTRACTED64(*frB, 0, 0);
      if (EXTRACTED64(*frB, 1, 11) == 0) {
        exp = -1022;
        frac_grx = INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      }
      if (EXTRACTED64(*frB, 1, 11) > 0) {
        exp = EXTRACTED64(*frB, 1, 11) - 1023;
        frac_grx = (BIT64(0) |
                    INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52));
      }
      /*Normalize_Operand:*/
        while (EXTRACTED64(frac_grx, 0, 0) == 0) {
          exp = exp - 1;
          frac_grx = INSERTED64(EXTRACTED64(frac_grx, 1, 52), 0, 51);
        }
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
      exp = exp + 192;
      *frT = (INSERTED64(sign, 0, 0)
              | INSERTED64(exp + 1023, 1, 11)
              | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
      if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
      GOTO(Done);
    /**/
    LABEL(Disabled_Exponent_Overflow):
      FPSCR_SET_OX(1);
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_to_nearest) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x7FF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xFFF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
        }
      }
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_zero) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x47EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xC7EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        }
      }
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_pos_infinity) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x7FF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xC7EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        }
      }
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_neg_infinity) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x47EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xFFF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
        }
      }
      /* FPSCR[FR] <- undefined */
      FPSCR_SET_FI(1);
      FPSCR_SET_XX(1);
      GOTO(Done);
    /**/
    LABEL(Enabled_Exponent_Overflow):
      sign = EXTRACTED64(*frB, 0, 0);
      exp = EXTRACTED64(*frB, 1, 11) - 1023;
      frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
    /**/
    LABEL(Enabled_Overflow):
      FPSCR_SET_OX(1);
      exp = exp - 192;
      *frT = (INSERTED64(sign, 0, 0)
              | INSERTED64(exp + 1023, 1, 11)
              | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
      if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
      GOTO(Done);
    /**/
    LABEL(Zero_Operand):
      *frT = *frB;
      if (EXTRACTED64(*frB, 0, 0) == 0) FPSCR_SET_FPRF(fpscr_rf_pos_zero);
      if (EXTRACTED64(*frB, 0, 0) == 1) FPSCR_SET_FPRF(fpscr_rf_neg_zero);
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(Infinity_Operand):
      *frT = *frB;
      if (EXTRACTED64(*frB, 0, 0) == 0) FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
      if (EXTRACTED64(*frB, 0, 0) == 1) FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(QNaN_Operand):
      *frT = INSERTED64(EXTRACTED64(*frB, 0, 34), 0, 34);
      FPSCR_SET_FPRF(fpscr_rf_quiet_nan);
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(SNaN_Operand):
      FPSCR_OR_VX(fpscr_vxsnan);
      if ((FPSCR & fpscr_ve) == 0) {
        *frT = (MASKED64(*frB, 0, 11)
                | BIT64(12)
                | MASKED64(*frB, 13, 34));
        FPSCR_SET_FPRF(fpscr_rf_quiet_nan);
      }
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(Normal_Operand):
      sign = EXTRACTED64(*frB, 0, 0);
      exp = EXTRACTED64(*frB, 1, 11) - 1023;
      frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
      if (exp > 127 && (FPSCR & fpscr_oe) == 0) GOTO(Disabled_Exponent_Overflow);
      if (exp > 127 && (FPSCR & fpscr_oe) != 0) GOTO(Enabled_Overflow);
      *frT = (INSERTED64(sign, 0, 0)
              | INSERTED64(exp + 1023, 1, 11)
              | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
      if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
      GOTO(Done);
    /**/
    LABEL(Done):
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 26670 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 26678 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Round_to_SinglePrecision_Rc1(cpu *processor,
                                               idecode_cache *cache_entry,
                                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Round_to_SinglePrecision
#undef MY_PREFIX
#define MY_PREFIX Floating_Round_to_SinglePrecision_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 26700 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4324 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Round to Single-Precision\n"));
#line 26706 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Round_to_SinglePrecision, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4324 "../.././sim/ppc/ppc-instructions"
  {
    int sign;
    int exp;
    unsigned64 frac_grx;
    /***/
      /* split off cases for what to do */
      if (EXTRACTED64(*frB, 1, 11) < 897
          && EXTRACTED64(*frB, 1, 63) > 0) {
          if ((FPSCR & fpscr_ue) == 0) GOTO(Disabled_Exponent_Underflow);
          if ((FPSCR & fpscr_ue) != 0) GOTO(Enabled_Exponent_Underflow);
      }
      if (EXTRACTED64(*frB, 1, 11) > 1150
          && EXTRACTED64(*frB, 1, 11) < 2047) {
          if ((FPSCR & fpscr_oe) == 0) GOTO(Disabled_Exponent_Overflow);
          if ((FPSCR & fpscr_oe) != 0) GOTO(Enabled_Exponent_Overflow);
      }
      if (EXTRACTED64(*frB, 1, 11) > 896
          && EXTRACTED64(*frB, 1, 11) < 1151) GOTO(Normal_Operand);
      if (EXTRACTED64(*frB, 1, 63) == 0) GOTO(Zero_Operand);
      if (EXTRACTED64(*frB, 1, 11) == 2047) {
        if (EXTRACTED64(*frB, 12, 63) == 0) GOTO(Infinity_Operand);
        if (EXTRACTED64(*frB, 12, 12) == 1) GOTO(QNaN_Operand);
        if (EXTRACTED64(*frB, 12, 12) == 0
            && EXTRACTED64(*frB, 13, 63) > 0) GOTO(SNaN_Operand);
      }
    /**/
    LABEL(Disabled_Exponent_Underflow):
      sign = EXTRACTED64(*frB, 0, 0);
      if (EXTRACTED64(*frB, 1, 11) == 0) {
        exp = -1022;
        frac_grx = INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      }
      if (EXTRACTED64(*frB, 1, 11) > 0) {
        exp = EXTRACTED64(*frB, 1, 11) - 1023;
        frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      }
        /* G|R|X == zero from above */
        while (exp < -126) {
          exp = exp + 1;
          frac_grx = (INSERTED64(EXTRACTED64(frac_grx, 0, 54), 1, 55)
                      | MASKED64(frac_grx, 55, 55));
        }
      FPSCR_SET_UX(EXTRACTED64(frac_grx, 24, 55) > 0);
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
      if (EXTRACTED64(frac_grx, 0, 52) == 0) {
        *frT = INSERTED64(sign, 0, 0);
        if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_zero);
        if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_zero);
      }
      if (EXTRACTED64(frac_grx, 0, 52) > 0) {
        if (EXTRACTED64(frac_grx, 0, 0) == 1) {
          if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
          if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        }
        if (EXTRACTED64(frac_grx, 0, 0) == 0) {
          if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_denormalized_number);
          if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_denormalized_number);
        }
        /*Normalize_Operand:*/
          while (EXTRACTED64(frac_grx, 0, 0) == 0) {
            exp = exp - 1;
            frac_grx = INSERTED64(EXTRACTED64(frac_grx, 1,  52), 0, 51);
          }
        *frT = (INSERTED64(sign, 0, 0)
                | INSERTED64(exp + 1023, 1, 11)
                | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      }
      GOTO(Done);
    /**/
    LABEL(Enabled_Exponent_Underflow):
      FPSCR_SET_UX(1);
      sign = EXTRACTED64(*frB, 0, 0);
      if (EXTRACTED64(*frB, 1, 11) == 0) {
        exp = -1022;
        frac_grx = INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      }
      if (EXTRACTED64(*frB, 1, 11) > 0) {
        exp = EXTRACTED64(*frB, 1, 11) - 1023;
        frac_grx = (BIT64(0) |
                    INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52));
      }
      /*Normalize_Operand:*/
        while (EXTRACTED64(frac_grx, 0, 0) == 0) {
          exp = exp - 1;
          frac_grx = INSERTED64(EXTRACTED64(frac_grx, 1, 52), 0, 51);
        }
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
      exp = exp + 192;
      *frT = (INSERTED64(sign, 0, 0)
              | INSERTED64(exp + 1023, 1, 11)
              | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
      if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
      GOTO(Done);
    /**/
    LABEL(Disabled_Exponent_Overflow):
      FPSCR_SET_OX(1);
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_to_nearest) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x7FF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xFFF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
        }
      }
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_zero) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x47EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xC7EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        }
      }
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_pos_infinity) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x7FF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xC7EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        }
      }
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_neg_infinity) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x47EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xFFF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
        }
      }
      /* FPSCR[FR] <- undefined */
      FPSCR_SET_FI(1);
      FPSCR_SET_XX(1);
      GOTO(Done);
    /**/
    LABEL(Enabled_Exponent_Overflow):
      sign = EXTRACTED64(*frB, 0, 0);
      exp = EXTRACTED64(*frB, 1, 11) - 1023;
      frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
    /**/
    LABEL(Enabled_Overflow):
      FPSCR_SET_OX(1);
      exp = exp - 192;
      *frT = (INSERTED64(sign, 0, 0)
              | INSERTED64(exp + 1023, 1, 11)
              | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
      if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
      GOTO(Done);
    /**/
    LABEL(Zero_Operand):
      *frT = *frB;
      if (EXTRACTED64(*frB, 0, 0) == 0) FPSCR_SET_FPRF(fpscr_rf_pos_zero);
      if (EXTRACTED64(*frB, 0, 0) == 1) FPSCR_SET_FPRF(fpscr_rf_neg_zero);
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(Infinity_Operand):
      *frT = *frB;
      if (EXTRACTED64(*frB, 0, 0) == 0) FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
      if (EXTRACTED64(*frB, 0, 0) == 1) FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(QNaN_Operand):
      *frT = INSERTED64(EXTRACTED64(*frB, 0, 34), 0, 34);
      FPSCR_SET_FPRF(fpscr_rf_quiet_nan);
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(SNaN_Operand):
      FPSCR_OR_VX(fpscr_vxsnan);
      if ((FPSCR & fpscr_ve) == 0) {
        *frT = (MASKED64(*frB, 0, 11)
                | BIT64(12)
                | MASKED64(*frB, 13, 34));
        FPSCR_SET_FPRF(fpscr_rf_quiet_nan);
      }
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(Normal_Operand):
      sign = EXTRACTED64(*frB, 0, 0);
      exp = EXTRACTED64(*frB, 1, 11) - 1023;
      frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
      if (exp > 127 && (FPSCR & fpscr_oe) == 0) GOTO(Disabled_Exponent_Overflow);
      if (exp > 127 && (FPSCR & fpscr_oe) != 0) GOTO(Enabled_Overflow);
      *frT = (INSERTED64(sign, 0, 0)
              | INSERTED64(exp + 1023, 1, 11)
              | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
      if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
      GOTO(Done);
    /**/
    LABEL(Done):
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 26930 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 26938 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Convert_To_Integer_Word_Rc0(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Convert_To_Integer_Word
#undef MY_PREFIX
#define MY_PREFIX Floating_Convert_To_Integer_Word_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 26960 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4545 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Convert To Integer Word\n"));
#line 26966 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Convert_To_Integer_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4545 "../.././sim/ppc/ppc-instructions"
  {
    floating_point_assist_interrupt(processor, cia);
  }
#line 26979 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 26987 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Convert_To_Integer_Word_Rc1(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Convert_To_Integer_Word
#undef MY_PREFIX
#define MY_PREFIX Floating_Convert_To_Integer_Word_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27009 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4545 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Convert To Integer Word\n"));
#line 27015 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Convert_To_Integer_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4545 "../.././sim/ppc/ppc-instructions"
  {
    floating_point_assist_interrupt(processor, cia);
  }
#line 27028 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27036 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc0(cpu *processor,
                                                                      idecode_cache *cache_entry,
                                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Convert_To_Integer_Word_with_round_towards_Zero
#undef MY_PREFIX
#define MY_PREFIX Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27058 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4552 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Convert To Integer Word with round towards Zero\n"));
#line 27064 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Convert_To_Integer_Word_with_round_towards_Zero, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4552 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    convert_to_integer(processor, cia,
                       frT, *frB,
                       fpscr_rn_round_towards_zero, 32);
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 27082 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27090 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc1(cpu *processor,
                                                                      idecode_cache *cache_entry,
                                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Convert_To_Integer_Word_with_round_towards_Zero
#undef MY_PREFIX
#define MY_PREFIX Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27112 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4552 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Convert To Integer Word with round towards Zero\n"));
#line 27118 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Convert_To_Integer_Word_with_round_towards_Zero, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4552 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    convert_to_integer(processor, cia,
                       frT, *frB,
                       fpscr_rn_round_towards_zero, 32);
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 27136 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27144 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Divide_Rc0(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Divide
#undef MY_PREFIX
#define MY_PREFIX Floating_Divide_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27168 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3893 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Divide\n"));
#line 27174 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Divide, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3893 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxzdz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else if (is_invalid_zero_divide (processor, cia,
                                     *frA, *frB,
                                     0 /*single?*/)) {
      invalid_zero_divide_operation (processor, cia,
                                     frT, *frA, *frB,
                                     0 /*single?*/);
    }
    else {
      /*HACK!*/
      double s = *(double*)frA / *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 27213 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27223 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Divide_Rc1(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Divide
#undef MY_PREFIX
#define MY_PREFIX Floating_Divide_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27247 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3893 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Divide\n"));
#line 27253 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Divide, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3893 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxzdz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else if (is_invalid_zero_divide (processor, cia,
                                     *frA, *frB,
                                     0 /*single?*/)) {
      invalid_zero_divide_operation (processor, cia,
                                     frT, *frA, *frB,
                                     0 /*single?*/);
    }
    else {
      /*HACK!*/
      double s = *(double*)frA / *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 27292 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27302 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Subtract_Rc0(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Subtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Subtract_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27326 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3789 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Subtract\n"));
#line 27332 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Subtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3789 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             1) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 27364 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27374 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Subtract_Rc1(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Subtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Subtract_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27398 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3789 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Subtract\n"));
#line 27404 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Subtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3789 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             1) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 27436 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27446 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Add_Rc0(cpu *processor,
                          idecode_cache *cache_entry,
                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Add
#undef MY_PREFIX
#define MY_PREFIX Floating_Add_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27470 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3737 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Add\n"));
#line 27476 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Add, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3737 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 27508 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27518 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Add_Rc1(cpu *processor,
                          idecode_cache *cache_entry,
                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Add
#undef MY_PREFIX
#define MY_PREFIX Floating_Add_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27542 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3737 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Add\n"));
#line 27548 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Add, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3737 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 27580 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27590 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Square_Root_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Square_Root
#undef MY_PREFIX
#define MY_PREFIX Floating_Square_Root_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27612 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4701 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Square Root\n"));
#line 27618 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Square_Root, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4701 "../.././sim/ppc/ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 27631 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27639 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Square_Root_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Square_Root
#undef MY_PREFIX
#define MY_PREFIX Floating_Square_Root_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27661 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4701 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Square Root\n"));
#line 27667 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Square_Root, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4701 "../.././sim/ppc/ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 27680 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27688 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC0_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC0_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27714 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 27720 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 27742 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 27754 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC0_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC0_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27780 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 27786 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 27808 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 27820 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC0_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC0_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27844 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 27850 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 27882 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 27892 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC0_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC0_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27916 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 27922 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 27954 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 27964 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Reciprocal_Square_Root_Estimate_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Reciprocal_Square_Root_Estimate
#undef MY_PREFIX
#define MY_PREFIX Floating_Reciprocal_Square_Root_Estimate_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27986 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4710 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Reciprocal Square Root Estimate\n"));
#line 27992 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Reciprocal_Square_Root_Estimate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4710 "../.././sim/ppc/ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 28005 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 28013 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Reciprocal_Square_Root_Estimate_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Reciprocal_Square_Root_Estimate
#undef MY_PREFIX
#define MY_PREFIX Floating_Reciprocal_Square_Root_Estimate_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 28035 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4710 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Reciprocal Square Root Estimate\n"));
#line 28041 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Reciprocal_Square_Root_Estimate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4710 "../.././sim/ppc/ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 28054 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 28062 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC0_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC0_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 28088 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 28094 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28145 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28157 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC0_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC0_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 28183 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 28189 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28240 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28252 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC0_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC0_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 28278 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 28284 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28335 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28347 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC0_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC0_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 28373 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 28379 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28430 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28442 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC0_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC0_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 28468 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 28474 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28525 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28537 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC0_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC0_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 28563 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 28569 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28620 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28632 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC0_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC0_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 28658 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 28664 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28715 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28727 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC0_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC0_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 28753 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 28759 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28810 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28822 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Compare_Ordered(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Compare_Ordered
#undef MY_PREFIX
#define MY_PREFIX Floating_Compare_Ordered

  /* extraction: 0.63,6.BF,9./,11.FRA,16.FRB,21.32,31./ #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.X.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.X.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#line 28845 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4621 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Compare Ordered\n"));
#line 28851 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Compare_Ordered, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4621 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned c;
    if (is_NaN(*frA, 0) || is_NaN(*frB, 0))
      c = cr_i_summary_overflow; /* 0b0001 - (FRA) ? (FRB) */
    else if (is_less_than(frA, frB))
      c = cr_i_negative; /* 0b1000 - (FRA) < (FRB) */
    else if (is_greater_than(frA, frB))
      c = cr_i_positive; /* 0b0100 - (FRA) > (FRB) */
    else
      c = cr_i_zero; /* 0b0010 - (FRA) = (FRB) */
    FPSCR_SET_FPCC(c);
    CR_SET(BF, c); /* CR[4*BF..4*BF+3] = c */
    if (is_SNaN(*frA, 0) || is_SNaN(*frB, 0)) {
      FPSCR_OR_VX(fpscr_vxsnan);
      if ((FPSCR & fpscr_ve) == 0)
        FPSCR_OR_VX(fpscr_vxvc);
    }
    else if (is_QNaN(*frA, 0) || is_QNaN(*frB, 0)) {
      FPSCR_OR_VX(fpscr_vxvc);
    }
    FPSCR_END(0);
    PPC_INSN_FLOAT_CR(0, FRA_BITMASK | FRB_BITMASK, BF_BITMASK);
  }
#line 28885 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BF,9./,11.FRA,16.FRB,21.32,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#line 28894 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Bit_1_Rc0(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Bit_1
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Bit_1_Rc0

  /* extraction: 0.63,6.BT,11./,16./,21.38,31.Rc #define get-values-from-icache */
#define BT cache_entry->crack.X.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.X.BT_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 28914 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4684 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Bit 1\n"));
#line 28920 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Bit_1, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4684 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned32 bit = BIT32(BT);
    if (bit & fpscr_fi)
      bit |= fpscr_xx;
    if ((bit & fpscr_vx_bits))
      bit |= fpscr_fx;
    /* note - omit vx bit */
    if ((bit & (fpscr_ox | fpscr_ux | fpscr_zx | fpscr_xx)))
      bit |= fpscr_fx;
    FPSCR |= bit;
    FPSCR_END(Rc);
  }
#line 28943 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BT,11./,16./,21.38,31.Rc #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef Rc
#line 28949 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Bit_1_Rc1(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Bit_1
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Bit_1_Rc1

  /* extraction: 0.63,6.BT,11./,16./,21.38,31.Rc #define get-values-from-icache */
#define BT cache_entry->crack.X.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.X.BT_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 28969 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4684 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Bit 1\n"));
#line 28975 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Bit_1, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4684 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned32 bit = BIT32(BT);
    if (bit & fpscr_fi)
      bit |= fpscr_xx;
    if ((bit & fpscr_vx_bits))
      bit |= fpscr_fx;
    /* note - omit vx bit */
    if ((bit & (fpscr_ox | fpscr_ux | fpscr_zx | fpscr_xx)))
      bit |= fpscr_fx;
    FPSCR |= bit;
    FPSCR_END(Rc);
  }
#line 28998 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BT,11./,16./,21.38,31.Rc #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef Rc
#line 29004 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negate_Rc0(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negate
#undef MY_PREFIX
#define MY_PREFIX Floating_Negate_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29026 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3705 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negate\n"));
#line 29032 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3705 "../.././sim/ppc/ppc-instructions"
  {
    *frT = *frB ^ BIT64(0);
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 29047 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 29055 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negate_Rc1(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negate
#undef MY_PREFIX
#define MY_PREFIX Floating_Negate_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 29077 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3705 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negate\n"));
#line 29083 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3705 "../.././sim/ppc/ppc-instructions"
  {
    *frT = *frB ^ BIT64(0);
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 29098 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 29106 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC1_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC1_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29132 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 29138 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 29160 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29172 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC1_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC1_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 29198 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 29204 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 29226 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29238 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC1_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC1_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29262 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 29268 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 29300 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29310 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC1_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC1_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 29334 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 29340 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 29372 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29382 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC1_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC1_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29408 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 29414 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 29465 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29477 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC1_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC1_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 29503 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 29509 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 29560 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29572 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC1_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC1_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29598 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 29604 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 29655 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29667 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC1_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC1_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 29693 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 29699 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 29750 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29762 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC1_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC1_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29788 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 29794 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 29845 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29857 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC1_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC1_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 29883 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 29889 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 29940 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29952 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC1_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC1_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29978 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 29984 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 30035 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30047 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC1_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC1_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30073 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 30079 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 30130 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30142 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_to_Condition_Register_from_FPSCR(cpu *processor,
                                               idecode_cache *cache_entry,
                                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Condition_Register_from_FPSCR
#undef MY_PREFIX
#define MY_PREFIX Move_to_Condition_Register_from_FPSCR

  /* extraction: 0.63,6.BF,9./,11.BFA,14./,16./,21.64,31./ #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define BFA cache_entry->crack.X.BFA /* default in icache - extraction */
#line 30162 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4655 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move to Condition Register from FPSCR\n"));
#line 30168 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_to_Condition_Register_from_FPSCR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4655 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned field = FPSCR_FIELD(BFA);
    CR_SET(BF, field);
    FPSCR_SET(BFA, 0); /* FPSCR_END fixes up FEX/VX */
    FPSCR_END(0);
  }
#line 30185 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BF,9./,11.BFA,14./,16./,21.64,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef BFA
#line 30191 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Bit_0_Rc0(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Bit_0
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Bit_0_Rc0

  /* extraction: 0.63,6.BT,11./,16./,21.70,31.Rc #define get-values-from-icache */
#define BT cache_entry->crack.X.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.X.BT_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 30211 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4678 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Bit 0\n"));
#line 30217 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Bit_0, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4678 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned32 bit = BIT32(BT);
    FPSCR &= ~bit;
    FPSCR_END(Rc);
  }
#line 30233 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BT,11./,16./,21.70,31.Rc #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef Rc
#line 30239 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Bit_0_Rc1(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Bit_0
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Bit_0_Rc1

  /* extraction: 0.63,6.BT,11./,16./,21.70,31.Rc #define get-values-from-icache */
#define BT cache_entry->crack.X.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.X.BT_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30259 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4678 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Bit 0\n"));
#line 30265 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Bit_0, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4678 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned32 bit = BIT32(BT);
    FPSCR &= ~bit;
    FPSCR_END(Rc);
  }
#line 30281 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BT,11./,16./,21.70,31.Rc #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef Rc
#line 30287 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Move_Register_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Move_Register
#undef MY_PREFIX
#define MY_PREFIX Floating_Move_Register_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 30309 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3696 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Move Register\n"));
#line 30315 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Move_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3696 "../.././sim/ppc/ppc-instructions"
  {
    *frT = *frB;
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 30330 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 30338 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Move_Register_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Move_Register
#undef MY_PREFIX
#define MY_PREFIX Floating_Move_Register_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30360 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3696 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Move Register\n"));
#line 30366 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Move_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3696 "../.././sim/ppc/ppc-instructions"
  {
    *frT = *frB;
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 30381 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 30389 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC2_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC2_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 30415 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 30421 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 30443 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30455 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC2_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC2_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30481 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 30487 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 30509 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30521 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC2_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC2_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 30545 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 30551 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 30583 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30593 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC2_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC2_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30617 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 30623 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 30655 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30665 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC2_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC2_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 30691 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 30697 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 30748 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30760 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC2_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC2_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30786 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 30792 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 30843 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30855 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC2_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC2_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 30881 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 30887 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 30938 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30950 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC2_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC2_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30976 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 30982 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31033 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31045 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC2_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC2_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 31071 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 31077 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31128 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31140 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC2_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC2_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 31166 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 31172 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31223 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31235 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC2_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC2_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 31261 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 31267 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31318 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31330 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC2_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC2_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 31356 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 31362 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31413 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31425 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC3_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC3_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 31451 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 31457 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 31479 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31491 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC3_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC3_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 31517 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 31523 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 31545 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31557 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC3_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC3_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 31581 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 31587 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 31619 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31629 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC3_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC3_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 31653 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 31659 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 31691 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31701 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC3_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC3_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 31727 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 31733 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31784 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31796 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC3_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC3_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 31822 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 31828 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31879 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31891 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC3_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC3_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 31917 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 31923 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31974 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31986 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC3_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC3_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32012 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 32018 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 32069 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32081 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC3_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC3_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32107 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 32113 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 32164 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32176 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC3_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC3_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32202 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 32208 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 32259 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32271 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC3_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC3_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32297 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 32303 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 32354 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32366 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC3_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC3_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32392 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 32398 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 32449 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32461 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Field_Immediate_Rc0(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Field_Immediate
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Field_Immediate_Rc0

  /* extraction: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define U cache_entry->crack.X.U /* default in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32482 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4662 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Field Immediate\n"));
#line 32488 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Field_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4662 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    FPSCR_SET(BF, U);
    FPSCR_END(Rc);
  }
#line 32503 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef U
#undef Rc
#line 32510 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Field_Immediate_Rc1(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Field_Immediate
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Field_Immediate_Rc1

  /* extraction: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define U cache_entry->crack.X.U /* default in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32531 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4662 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Field Immediate\n"));
#line 32537 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Field_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4662 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    FPSCR_SET(BF, U);
    FPSCR_END(Rc);
  }
#line 32552 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef U
#undef Rc
#line 32559 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_Absolute_Value_Rc0(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_Absolute_Value
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_Absolute_Value_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32581 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3723 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Absolute Value\n"));
#line 32587 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_Absolute_Value, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3723 "../.././sim/ppc/ppc-instructions"
  {
    *frT = *frB | BIT64(0);
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 32602 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 32610 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_Absolute_Value_Rc1(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_Absolute_Value
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_Absolute_Value_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32632 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3723 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Absolute Value\n"));
#line 32638 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_Absolute_Value, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3723 "../.././sim/ppc/ppc-instructions"
  {
    *frT = *frB | BIT64(0);
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 32653 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 32661 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC4_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC4_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32687 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 32693 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 32715 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32727 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC4_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC4_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32753 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 32759 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 32781 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32793 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC4_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC4_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32817 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 32823 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 32855 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32865 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC4_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC4_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32889 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 32895 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 32927 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32937 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC4_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC4_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32963 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 32969 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33020 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33032 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC4_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC4_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 33058 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 33064 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33115 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33127 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC4_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC4_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 33153 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 33159 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33210 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33222 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC4_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC4_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 33248 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 33254 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33305 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33317 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC4_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC4_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 33343 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 33349 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33400 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33412 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC4_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC4_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 33438 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 33444 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33495 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33507 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC4_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC4_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 33533 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 33539 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33590 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33602 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC4_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC4_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 33628 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 33634 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33685 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33697 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC5_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC5_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 33723 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 33729 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 33751 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33763 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC5_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC5_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 33789 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 33795 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 33817 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33829 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC5_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC5_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 33853 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 33859 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 33891 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33901 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC5_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC5_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 33925 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 33931 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 33963 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33973 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC5_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC5_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 33999 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 34005 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34056 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34068 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC5_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC5_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 34094 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 34100 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34151 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34163 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC5_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC5_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 34189 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 34195 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34246 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34258 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC5_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC5_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 34284 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 34290 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34341 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34353 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC5_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC5_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 34379 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 34385 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34436 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34448 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC5_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC5_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 34474 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 34480 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34531 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34543 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC5_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC5_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 34569 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 34575 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34626 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34638 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC5_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC5_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 34664 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 34670 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34721 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34733 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC6_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC6_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 34759 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 34765 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 34787 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34799 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC6_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC6_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 34825 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 34831 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 34853 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34865 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC6_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC6_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 34889 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 34895 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 34927 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34937 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC6_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC6_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 34961 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 34967 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 34999 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35009 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC6_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC6_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 35035 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 35041 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35092 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35104 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC6_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC6_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 35130 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 35136 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35187 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35199 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC6_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC6_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 35225 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 35231 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35282 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35294 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC6_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC6_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 35320 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 35326 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35377 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35389 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC6_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC6_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 35415 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 35421 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35472 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35484 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC6_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC6_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 35510 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 35516 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35567 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35579 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC6_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC6_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 35605 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 35611 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35662 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35674 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC6_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC6_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 35700 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 35706 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35757 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35769 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC7_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC7_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 35795 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 35801 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 35823 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35835 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC7_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC7_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 35861 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 35867 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 35889 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35901 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC7_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC7_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 35925 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 35931 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 35963 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35973 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC7_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC7_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 35997 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 36003 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 36035 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36045 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC7_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC7_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 36071 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 36077 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36128 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36140 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC7_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC7_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 36166 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 36172 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36223 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36235 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC7_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC7_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 36261 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 36267 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36318 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36330 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC7_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC7_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 36356 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 36362 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36413 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36425 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC7_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC7_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 36451 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 36457 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36508 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36520 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC7_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC7_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 36546 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 36552 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36603 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36615 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC7_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC7_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 36641 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 36647 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36698 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36710 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC7_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC7_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 36736 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 36742 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36793 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36805 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Absolute_Value_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Absolute_Value
#undef MY_PREFIX
#define MY_PREFIX Floating_Absolute_Value_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 36827 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3714 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Absolute Value\n"));
#line 36833 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Absolute_Value, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3714 "../.././sim/ppc/ppc-instructions"
  {
    *frT = *frB & ~BIT64(0);
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 36848 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 36856 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Absolute_Value_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Absolute_Value
#undef MY_PREFIX
#define MY_PREFIX Floating_Absolute_Value_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 36878 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3714 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Absolute Value\n"));
#line 36884 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Absolute_Value, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3714 "../.././sim/ppc/ppc-instructions"
  {
    *frT = *frB & ~BIT64(0);
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 36899 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 36907 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC8_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC8_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 36933 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 36939 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 36961 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36973 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC8_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC8_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 36999 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 37005 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 37027 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37039 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC8_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC8_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 37063 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 37069 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 37101 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37111 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC8_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC8_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 37135 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 37141 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 37173 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37183 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC8_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC8_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 37209 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 37215 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37266 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37278 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC8_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC8_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 37304 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 37310 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37361 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37373 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC8_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC8_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 37399 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 37405 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37456 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37468 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC8_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC8_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 37494 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 37500 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37551 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37563 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC8_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC8_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 37589 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 37595 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37646 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37658 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC8_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC8_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 37684 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 37690 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37741 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37753 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC8_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC8_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 37779 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 37785 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37836 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37848 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC8_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC8_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 37874 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 37880 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37931 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37943 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC9_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC9_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 37969 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 37975 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 37997 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38009 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC9_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC9_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 38035 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 38041 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 38063 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38075 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC9_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC9_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 38099 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 38105 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 38137 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38147 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC9_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC9_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 38171 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 38177 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 38209 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38219 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC9_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC9_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 38245 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 38251 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38302 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38314 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC9_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC9_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 38340 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 38346 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38397 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38409 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC9_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC9_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 38435 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 38441 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38492 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38504 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC9_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC9_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 38530 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 38536 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38587 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38599 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC9_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC9_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 38625 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 38631 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38682 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38694 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC9_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC9_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 38720 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 38726 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38777 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38789 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC9_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC9_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 38815 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 38821 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38872 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38884 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC9_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC9_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 38910 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 38916 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38967 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38979 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC10_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC10_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 39005 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 39011 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 39033 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39045 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC10_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC10_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 39071 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 39077 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 39099 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39111 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC10_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC10_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 39135 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 39141 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 39173 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39183 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC10_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC10_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 39207 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 39213 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 39245 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39255 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC10_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC10_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 39281 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 39287 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39338 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39350 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC10_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC10_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 39376 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 39382 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39433 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39445 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC10_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC10_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 39471 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 39477 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39528 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39540 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC10_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC10_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 39566 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 39572 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39623 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39635 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC10_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC10_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 39661 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 39667 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39718 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39730 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC10_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC10_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 39756 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 39762 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39813 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39825 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC10_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC10_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 39851 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 39857 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39908 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39920 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC10_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC10_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 39946 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 39952 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40003 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40015 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC11_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC11_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 40041 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 40047 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 40069 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40081 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC11_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC11_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 40107 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 40113 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 40135 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40147 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC11_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC11_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 40171 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 40177 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 40209 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40219 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC11_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC11_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 40243 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 40249 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 40281 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40291 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC11_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC11_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 40317 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 40323 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40374 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40386 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC11_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC11_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 40412 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 40418 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40469 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40481 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC11_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC11_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 40507 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 40513 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40564 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40576 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC11_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC11_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 40602 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 40608 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40659 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40671 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC11_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC11_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 40697 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 40703 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40754 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40766 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC11_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC11_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 40792 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 40798 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40849 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40861 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC11_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC11_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 40887 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 40893 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40944 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40956 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC11_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC11_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 40982 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 40988 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41039 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41051 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC12_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC12_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 41077 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 41083 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 41105 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41117 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC12_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC12_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 41143 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 41149 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 41171 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41183 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC12_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC12_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 41207 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 41213 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 41245 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41255 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC12_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC12_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 41279 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 41285 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 41317 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41327 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC12_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC12_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 41353 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 41359 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41410 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41422 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC12_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC12_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 41448 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 41454 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41505 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41517 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC12_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC12_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 41543 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 41549 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41600 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41612 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC12_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC12_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 41638 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 41644 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41695 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41707 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC12_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC12_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 41733 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 41739 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41790 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41802 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC12_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC12_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 41828 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 41834 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41885 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41897 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC12_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC12_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 41923 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 41929 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41980 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41992 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC12_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC12_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 42018 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 42024 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42075 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42087 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC13_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC13_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 42113 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 42119 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 42141 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42153 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC13_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC13_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 42179 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 42185 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 42207 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42219 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC13_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC13_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 42243 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 42249 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 42281 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42291 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC13_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC13_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 42315 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 42321 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 42353 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42363 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC13_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC13_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 42389 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 42395 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42446 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42458 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC13_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC13_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 42484 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 42490 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42541 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42553 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC13_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC13_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 42579 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 42585 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42636 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42648 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC13_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC13_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 42674 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 42680 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42731 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42743 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC13_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC13_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 42769 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 42775 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42826 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42838 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC13_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC13_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 42864 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 42870 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42921 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42933 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC13_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC13_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 42959 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 42965 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43016 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43028 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC13_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC13_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 43054 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 43060 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43111 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43123 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC14_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC14_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 43149 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 43155 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 43177 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43189 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC14_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC14_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 43215 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 43221 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 43243 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43255 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC14_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC14_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 43279 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 43285 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 43317 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43327 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC14_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC14_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 43351 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 43357 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 43389 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43399 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC14_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC14_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 43425 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 43431 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43482 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43494 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC14_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC14_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 43520 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 43526 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43577 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43589 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC14_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC14_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 43615 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 43621 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43672 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43684 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC14_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC14_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 43710 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 43716 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43767 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43779 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC14_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC14_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 43805 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 43811 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43862 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43874 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC14_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC14_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 43900 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 43906 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43957 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43969 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC14_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC14_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 43995 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 44001 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44052 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44064 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC14_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC14_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 44090 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 44096 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44147 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44159 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC15_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC15_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 44185 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 44191 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 44213 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44225 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC15_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC15_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 44251 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 44257 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 44279 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44291 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC15_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC15_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 44315 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 44321 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 44353 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44363 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC15_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC15_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 44387 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 44393 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 44425 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44435 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC15_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC15_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 44461 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 44467 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44518 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44530 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC15_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC15_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 44556 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 44562 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44613 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44625 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC15_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC15_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 44651 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 44657 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44708 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44720 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC15_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC15_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 44746 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 44752 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44803 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44815 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC15_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC15_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 44841 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 44847 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44898 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44910 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC15_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC15_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 44936 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 44942 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44993 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45005 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC15_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC15_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 45031 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 45037 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45088 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45100 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC15_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC15_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 45126 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 45132 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45183 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45195 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC16_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC16_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 45221 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 45227 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 45249 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45261 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC16_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC16_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 45287 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 45293 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 45315 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45327 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC16_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC16_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 45351 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 45357 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 45389 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45399 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC16_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC16_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 45423 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 45429 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 45461 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45471 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC16_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC16_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 45497 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 45503 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45554 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45566 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC16_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC16_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 45592 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 45598 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45649 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45661 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC16_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC16_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 45687 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 45693 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45744 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45756 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC16_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC16_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 45782 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 45788 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45839 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45851 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC16_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC16_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 45877 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 45883 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45934 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45946 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC16_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC16_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 45972 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 45978 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46029 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46041 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC16_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC16_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 46067 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 46073 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46124 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46136 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC16_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC16_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 46162 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 46168 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46219 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46231 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC17_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC17_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 46257 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 46263 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 46285 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46297 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC17_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC17_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 46323 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 46329 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 46351 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46363 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC17_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC17_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 46387 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 46393 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 46425 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46435 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC17_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC17_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 46459 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 46465 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 46497 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46507 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC17_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC17_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 46533 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 46539 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46590 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46602 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC17_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC17_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 46628 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 46634 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46685 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46697 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC17_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC17_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 46723 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 46729 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46780 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46792 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC17_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC17_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 46818 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 46824 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46875 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46887 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC17_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC17_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 46913 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 46919 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46970 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46982 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC17_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC17_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47008 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 47014 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 47065 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47077 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC17_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC17_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 47103 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 47109 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 47160 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47172 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC17_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC17_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47198 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 47204 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 47255 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47267 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_FPSCR_Rc0(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_FPSCR
#undef MY_PREFIX
#define MY_PREFIX Move_From_FPSCR_Rc0

  /* extraction: 0.63,6.FRT,11./,16./,21.583,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 47287 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4650 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From FPSCR\n"));
#line 47293 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_FPSCR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4650 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    *frT = FPSCR;
    FPSCR_END(Rc);
  }
#line 47308 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16./,21.583,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef Rc
#line 47314 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_FPSCR_Rc1(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_FPSCR
#undef MY_PREFIX
#define MY_PREFIX Move_From_FPSCR_Rc1

  /* extraction: 0.63,6.FRT,11./,16./,21.583,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47334 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4650 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From FPSCR\n"));
#line 47340 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_FPSCR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4650 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    *frT = FPSCR;
    FPSCR_END(Rc);
  }
#line 47355 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16./,21.583,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef Rc
#line 47361 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC18_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC18_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 47387 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 47393 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 47415 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47427 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC18_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC18_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47453 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 47459 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 47481 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47493 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC18_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC18_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 47517 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 47523 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 47555 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47565 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC18_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC18_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47589 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 47595 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 47627 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47637 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC18_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC18_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 47663 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 47669 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 47720 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47732 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC18_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC18_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47758 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 47764 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 47815 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47827 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC18_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC18_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 47853 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 47859 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 47910 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47922 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC18_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC18_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47948 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 47954 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48005 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48017 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC18_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC18_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 48043 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 48049 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48100 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48112 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC18_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC18_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 48138 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 48144 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48195 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48207 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC18_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC18_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 48233 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 48239 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48290 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48302 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC18_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC18_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 48328 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 48334 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48385 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48397 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC19_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC19_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 48423 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 48429 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 48451 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48463 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC19_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC19_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 48489 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 48495 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 48517 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48529 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC19_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC19_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 48553 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 48559 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 48591 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48601 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC19_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC19_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 48625 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 48631 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 48663 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48673 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC19_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC19_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 48699 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 48705 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48756 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48768 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC19_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC19_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 48794 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 48800 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48851 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48863 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC19_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC19_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 48889 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 48895 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48946 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48958 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC19_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC19_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 48984 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 48990 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49041 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49053 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC19_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC19_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 49079 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 49085 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49136 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49148 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC19_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC19_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 49174 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 49180 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49231 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49243 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC19_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC19_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 49269 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 49275 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49326 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49338 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC19_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC19_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 49364 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 49370 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49421 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49433 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC20_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC20_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 49459 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 49465 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 49487 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49499 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC20_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC20_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 49525 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 49531 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 49553 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49565 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC20_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC20_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 49589 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 49595 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 49627 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49637 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC20_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC20_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 49661 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 49667 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 49699 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49709 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC20_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC20_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 49735 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 49741 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49792 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49804 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC20_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC20_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 49830 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 49836 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49887 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49899 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC20_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC20_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 49925 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 49931 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49982 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49994 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC20_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC20_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 50020 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 50026 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50077 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50089 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC20_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC20_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 50115 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 50121 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50172 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50184 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC20_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC20_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 50210 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 50216 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50267 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50279 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC20_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC20_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 50305 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 50311 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50362 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50374 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC20_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC20_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 50400 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 50406 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50457 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50469 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC21_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC21_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 50495 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 50501 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 50523 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50535 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC21_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC21_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 50561 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 50567 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 50589 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50601 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC21_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC21_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 50625 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 50631 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 50663 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50673 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC21_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC21_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 50697 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 50703 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 50735 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50745 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC21_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC21_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 50771 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 50777 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50828 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50840 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC21_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC21_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 50866 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 50872 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50923 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50935 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC21_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC21_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 50961 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 50967 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51018 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51030 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC21_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC21_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 51056 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 51062 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51113 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51125 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC21_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC21_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 51151 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 51157 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51208 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51220 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC21_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC21_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 51246 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 51252 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51303 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51315 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC21_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC21_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 51341 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 51347 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51398 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51410 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC21_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC21_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 51436 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 51442 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51493 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51505 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Fields_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Fields
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Fields_Rc0

  /* extraction: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc #define get-values-from-icache */
#define FLM cache_entry->crack.XFL.FLM /* default in icache - extraction */
#define frB cache_entry->crack.XFL.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.XFL.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 51526 "semantics.c"

#define insn cache_entry->crack.XFL.insn
  unsigned_word nia;
#line 4667 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Fields\n"));
#line 51532 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Fields, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4667 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    int i;
    for (i = 0; i < 8; i++) {
      if ((FLM & BIT8(i))) {
        FPSCR &= ~MASK32(i*4, i*4+3);
        FPSCR |= MASKED32(*frB, i*4, i*4+3);
      }
    }
    FPSCR_END(Rc);
  }
#line 51553 "semantics.c"
  return nia;
  /* extraction: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc #undef get-values-from-icache */
#undef FLM
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 51560 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Fields_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Fields
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Fields_Rc1

  /* extraction: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc #define get-values-from-icache */
#define FLM cache_entry->crack.XFL.FLM /* default in icache - extraction */
#define frB cache_entry->crack.XFL.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.XFL.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 51581 "semantics.c"

#define insn cache_entry->crack.XFL.insn
  unsigned_word nia;
#line 4667 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Fields\n"));
#line 51587 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Fields, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4667 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    int i;
    for (i = 0; i < 8; i++) {
      if ((FLM & BIT8(i))) {
        FPSCR &= ~MASK32(i*4, i*4+3);
        FPSCR |= MASKED32(*frB, i*4, i*4+3);
      }
    }
    FPSCR_END(Rc);
  }
#line 51608 "semantics.c"
  return nia;
  /* extraction: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc #undef get-values-from-icache */
#undef FLM
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 51615 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC22_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC22_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 51641 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 51647 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 51669 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51681 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC22_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC22_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 51707 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 51713 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 51735 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51747 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC22_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC22_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 51771 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 51777 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 51809 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51819 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC22_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC22_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 51843 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 51849 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 51881 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51891 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC22_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC22_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 51917 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 51923 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51974 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51986 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC22_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC22_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 52012 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 52018 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52069 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52081 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC22_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC22_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 52107 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 52113 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52164 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52176 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC22_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC22_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 52202 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 52208 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52259 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52271 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC22_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC22_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 52297 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 52303 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52354 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52366 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC22_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC22_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 52392 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 52398 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52449 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52461 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC22_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC22_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 52487 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 52493 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52544 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52556 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC22_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC22_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 52582 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 52588 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52639 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52651 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC23_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC23_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 52677 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 52683 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 52705 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52717 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC23_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC23_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 52743 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 52749 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 52771 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52783 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC23_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC23_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 52807 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 52813 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 52845 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52855 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC23_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC23_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 52879 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 52885 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 52917 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52927 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC23_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC23_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 52953 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 52959 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53010 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53022 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC23_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC23_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 53048 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 53054 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53105 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53117 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC23_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC23_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 53143 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 53149 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53200 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53212 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC23_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC23_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 53238 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 53244 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53295 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53307 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC23_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC23_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 53333 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 53339 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53390 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53402 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC23_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC23_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 53428 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 53434 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53485 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53497 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC23_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC23_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 53523 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 53529 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53580 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53592 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC23_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC23_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 53618 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 53624 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53675 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53687 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC24_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC24_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 53713 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 53719 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 53741 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53753 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC24_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC24_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 53779 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 53785 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 53807 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53819 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC24_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC24_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 53843 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 53849 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 53881 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53891 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC24_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC24_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 53915 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 53921 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 53953 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53963 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC24_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC24_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 53989 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 53995 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54046 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54058 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC24_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC24_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 54084 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 54090 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54141 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54153 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC24_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC24_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 54179 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 54185 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54236 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54248 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC24_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC24_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 54274 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 54280 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54331 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54343 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC24_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC24_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 54369 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 54375 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54426 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54438 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC24_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC24_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 54464 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 54470 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54521 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54533 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC24_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC24_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 54559 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 54565 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54616 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54628 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC24_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC24_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 54654 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 54660 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54711 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54723 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC25_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC25_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 54749 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 54755 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 54777 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54789 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC25_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC25_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 54815 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 54821 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 54843 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54855 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC25_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC25_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 54879 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 54885 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 54917 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54927 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC25_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC25_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 54951 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 54957 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 54989 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54999 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC25_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC25_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 55025 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 55031 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55082 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55094 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC25_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC25_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 55120 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 55126 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55177 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55189 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC25_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC25_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 55215 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 55221 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55272 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55284 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC25_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC25_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 55310 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 55316 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55367 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55379 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC25_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC25_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 55405 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 55411 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55462 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55474 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC25_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC25_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 55500 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 55506 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55557 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55569 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC25_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC25_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 55595 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 55601 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55652 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55664 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC25_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC25_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 55690 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 55696 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55747 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55759 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC26_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC26_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 55785 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 55791 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 55813 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55825 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC26_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC26_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 55851 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 55857 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 55879 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55891 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC26_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC26_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 55915 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 55921 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 55953 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55963 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC26_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC26_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 55987 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 55993 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 56025 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56035 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC26_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC26_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 56061 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 56067 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56118 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56130 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC26_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC26_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 56156 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 56162 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56213 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56225 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC26_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC26_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 56251 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 56257 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56308 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56320 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC26_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC26_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 56346 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 56352 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56403 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56415 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC26_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC26_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 56441 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 56447 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56498 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56510 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC26_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC26_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 56536 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 56542 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56593 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56605 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC26_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC26_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 56631 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 56637 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56688 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56700 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC26_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC26_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 56726 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 56732 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56783 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56795 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC27_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC27_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 56821 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 56827 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 56849 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56861 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC27_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC27_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 56887 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 56893 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 56915 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56927 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC27_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC27_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 56951 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 56957 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 56989 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56999 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC27_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC27_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 57023 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 57029 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 57061 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57071 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC27_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC27_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 57097 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 57103 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57154 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57166 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC27_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC27_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 57192 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 57198 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57249 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57261 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC27_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC27_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 57287 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 57293 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57344 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57356 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC27_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC27_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 57382 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 57388 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57439 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57451 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC27_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC27_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 57477 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 57483 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57534 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57546 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC27_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC27_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 57572 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 57578 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57629 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57641 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC27_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC27_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 57667 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 57673 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57724 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57736 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC27_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC27_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 57762 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 57768 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57819 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57831 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC28_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC28_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 57857 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 57863 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 57885 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57897 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC28_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC28_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 57923 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 57929 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 57951 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57963 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC28_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC28_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 57987 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 57993 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 58025 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58035 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC28_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC28_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 58059 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 58065 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 58097 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58107 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC28_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC28_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 58133 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 58139 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58190 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58202 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC28_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC28_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 58228 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 58234 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58285 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58297 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC28_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC28_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 58323 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 58329 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58380 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58392 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC28_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC28_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 58418 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 58424 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58475 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58487 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC28_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC28_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 58513 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 58519 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58570 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58582 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC28_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC28_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 58608 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 58614 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58665 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58677 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC28_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC28_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 58703 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 58709 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58760 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58772 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC28_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC28_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 58798 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 58804 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58855 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58867 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC29_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC29_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 58893 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 58899 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 58921 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58933 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC29_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC29_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 58959 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 58965 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 58987 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58999 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC29_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC29_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 59023 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 59029 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 59061 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59071 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC29_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC29_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 59095 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 59101 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 59133 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59143 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC29_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC29_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 59169 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 59175 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59226 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59238 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC29_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC29_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 59264 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 59270 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59321 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59333 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC29_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC29_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 59359 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 59365 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59416 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59428 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC29_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC29_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 59454 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 59460 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59511 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59523 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC29_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC29_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 59549 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 59555 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59606 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59618 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC29_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC29_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 59644 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 59650 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59701 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59713 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC29_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC29_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 59739 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 59745 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59796 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59808 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC29_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC29_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 59834 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 59840 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59891 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59903 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC30_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC30_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 59929 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 59935 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 59957 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59969 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC30_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC30_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 59995 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 60001 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 60023 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60035 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC30_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC30_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 60059 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 60065 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 60097 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60107 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC30_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC30_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 60131 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 60137 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 60169 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60179 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC30_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC30_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 60205 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 60211 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60262 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60274 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC30_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC30_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 60300 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 60306 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60357 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60369 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC30_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC30_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 60395 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 60401 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60452 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60464 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC30_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC30_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 60490 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 60496 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60547 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60559 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC30_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC30_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 60585 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 60591 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60642 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60654 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC30_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC30_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 60680 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 60686 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60737 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60749 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC30_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC30_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 60775 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 60781 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60832 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60844 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC30_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC30_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 60870 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 60876 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60927 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60939 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC31_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC31_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 60965 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 60971 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 60993 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61005 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC31_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC31_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 61031 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4721 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 61037 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4721 "../.././sim/ppc/ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 61059 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61071 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC31_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC31_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 61095 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 61101 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 61133 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61143 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC31_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC31_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 61167 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3841 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 61173 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3841 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 61205 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61215 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC31_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC31_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 61241 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 61247 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61298 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61310 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC31_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC31_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 61336 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4049 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 61342 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4049 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61393 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61405 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC31_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC31_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 61431 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 61437 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61488 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61500 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC31_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC31_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 61526 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3959 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 61532 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3959 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61583 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61595 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC31_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC31_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 61621 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 61627 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61678 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61690 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC31_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC31_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 61716 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4229 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 61722 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4229 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61773 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61785 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC31_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC31_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 61811 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 61817 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61868 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61880 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC31_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC31_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 61906 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4139 "../.././sim/ppc/ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 61912 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4139 "../.././sim/ppc/ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61963 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61975 "semantics.c"

#undef insn
}

#endif /* _SEMANTICS_C_*/
